#include "em_gpio.h"
#include "ikk-user.h"
#include "./general/ikk-sequence.h"
#include "./callback.h"
#include "app/framework/plugin/scenes/scenes.h"
#include <00ikonke-app/general/ikk-opt-tunnel.h>
/*********
 * ReleaseNotes:
 *
 * V1.0 20200819
 * 1ϵ3-6sʱϱ
 * 2ܵFCC0Э˽֮Զϱ׼ϱ1-4 onoff״̬
 * 3̵Ӧϵɶఴͬһ̵һ󶨶̵
 ******/

#define		DUAL_LIGHT_PANEL

#ifdef SINGLE_LIGHT_PANEL
#define 	g_ucRelayTotalNum  1
#endif

#ifdef DUAL_LIGHT_PANEL
#define 	g_ucRelayTotalNum  2
#endif

#ifdef THREE_LIGHT_PANEL
#define 	g_ucRelayTotalNum  3
#endif

#ifdef FOUR_LIGHT_PANEL
#define 	g_ucRelayTotalNum  4
#endif

/*********
 * PD0	 RELAY1
 * PC0	 RELAY2
 * PC4	 RELAY3
 * PC3   ZERO_INT
 * PB1   LED_SYS
 * PD2	 LED1
 * PA6	 LED2
 * PA0	 LED3
 * PA3	 LED2A
 * PC2   KEY_SET
 * PC5   KEY1
 * PD3	 KEY2
 * PB0	 KEY3
 * PA5	 KEY2A
 *
 */
#define HEART_TEST	false
//ϵ󲻻ָonoff
#define RESTORE_ONOFF_STATUS  0

uint8_t g_bIsRecoveryRelayStatus = RESTORE_ONOFF_STATUS;
uint8_t runStatus = RUN_STATUS_NORMAL ;
#define ZERO_PORT		gpioPortC
#define ZERO_PIN		3

#define RELAY1_PORT		gpioPortD
#define RELAY1_PIN		0
#define RELAY2_PORT		gpioPortC
#define RELAY2_PIN		0
#define RELAY3_PORT		gpioPortC
#define RELAY3_PIN		4
#define RELAY4_PORT		gpioPortC
#define RELAY4_PIN		1

#define LED_RADAR_PORT	gpioPortB
#define LED_RADAR_PIN	1
#define LED1_PORT		gpioPortD
#define LED1_PIN		2
#define LED2_PORT		gpioPortA
#define LED2_PIN		6
#define LED3_PORT		gpioPortA
#define LED3_PIN		0
#define LED4_PORT		gpioPortD
#define LED4_PIN		4

#define KEY_SYS_PORT	gpioPortC
#define KEY_SYS_PIN		2
#define KEY1_PORT		gpioPortC
#define KEY1_PIN		5
#define KEY2_PORT		gpioPortD
#define KEY2_PIN		3
#define KEY3_PORT		gpioPortB
#define KEY3_PIN		0
#define KEY4_PORT		gpioPortA
#define KEY4_PIN		4
#define RADAR_PORT		gpioPortD
#define RADAR_PIN		1

//delay to report cmei and isn after network joined
#define DELAY_REPORT_DATA_AFTER_NWK_JOINED_MS	(3 * 1000)

#define SYS_BUTTON_LONG_PRESS_TIME_MS			(5 * 1000)
#define SENSOR_LONG_PRESS_TIME_MS				200

#define IR_SENSOR_LOCK_TIME_MS					(15 * 1000)

//battery low power limit value when report IAS body sensor
//#define BATTERY_LOWPOWER_LIMIT_VAL_MV			2450

#define RELAY_OUTPUT							0
#define RELAY_INPUT								1

#define RAND_MIN_NUM							(3 * 1000) //С,λMS
#define RAND_MAX_NUM 							(6 * 1000) //

#define HEART_RAND_MIN_NUM						(240 * 1000)
#define HEART_RAND_MAX_NUM						(300 * 1000)

#define MIN_JOINED_NWK_DELAY_TIME_MS 			(7 * 1000) //ϵʱ䣬жǷʱ10~40SϱCMEIISN

#define MAX_FIRST_USER_KEY_LEAVE_NWK_INTERVAL_TIME_MS (14 * 1000)//һʱ

#define BOOT_DONE_TIME_MS						(5)

#define HEART_DEBUG 							1
#if HEART_DEBUG
#define HEARTBEAT_TIME_MS						(2 * 60 * 1000)
#else
#define HEARTBEAT_TIME_MS						kUtilsGetRandNum(HEART_RAND_MIN_NUM, HEART_RAND_MAX_NUM)
#endif

#define ENDPOINT_MAX_NUM						4
//ģʽʱLEDʱ
#define NO_DISTURB_MODE_LED_ON_TIME_MS			(10 * 1000)
#define	OFF_DISTURB_MODE_LED_OFF_LEVEL			0
#define RADAR_ON_TIME_MS	  					10000

#define LED_SLOW_BLINK_ON_TIME_MS				500
#define LED_SLOW_BLINK_OFF_TIME_MS				500
#define LED_FAST_BLINK_ON_TIME_MS				200
#define LED_FAST_BLINK_OFF_TIME_MS				200

#define LED_SLOW_BLINK_CONTINUE_TIME_MS			(60 * 1000)
#define LED_FAST_BLINK_CONTINUE_TIME_MS			(5 * 1000)

//join nwk timeout
#define NWK_STEERING_TIMEOUT_MS 				(60 * 1000)

#define CHECKED_ZERO_DELAY_ON_TIME_MS			(6000)//̵ʱ⵽󣬰ػ·ʱȥʱ䣬
#define CHECKED_ZERO_DELAY_OFF_TIME_MS			(5970)//̵ʱ⵽󣬰ػ·ʱȥصʱ䣬

#define REPORT_ATTR_MAX_RAND_NUM				(7 * 1000) //·ƺʱϱ״̬,״̬ıSDKϱ
#define REPORT_ATTR_MIN_RAND_NUM				(2.5 * 1000) //·ƺСʱϱ״̬

typedef enum {KEY_SYS_ID = 1,KEY1_ID, KEY2_ID, KEY3_ID, KEY4_ID , RADAR_ID}KEY_ID_ENUM;
typedef enum {LED_RADAR_ID = 1,LED1_ID, LED2_ID, LED3_ID, LED4_ID, LED_ALL_ID}LED_ID_ENUM;
typedef enum {RELAY_CHANNEL1_ID=1, RELAY_CHANNEL2_ID, RELAY_CHANNEL3_ID, RELAY_CHANNEL4_ID, RELAY_ALL_ID}RELAY_ID_ENUM;
typedef enum {PWM1_ID = 1,PWM2_ID, PWM3_ID, PWM4_ID, PWM5_ID, PWM6_ID, PWM7_ID, PWM8_ID}PWM_ID_ENUM;

#define CURRENT_ENDPOINT(button_id)		(button_id == KEY1_ID?1:(button_id == KEY2_ID?2:3))

typedef enum{
	NO_DISTURB_RELAY_OFF_LED_OFF = 0,
	NO_DISTURB_RELAY_ON_LED_10S_DELAY,
	NO_DISTURB_RELAY_ON_LED_OFF,
}NO_DISTURB_MODE_STATUS_E;

typedef struct{
	uint8_t endpoint;
	NO_DISTURB_MODE_STATUS_E status;
}NoDisturbMode_ST;

NoDisturbMode_ST g_stNoDisturbModeStatus[ENDPOINT_MAX_NUM] = {
		{1,NO_DISTURB_RELAY_OFF_LED_OFF},
		{2,NO_DISTURB_RELAY_OFF_LED_OFF},
		{3,NO_DISTURB_RELAY_OFF_LED_OFF},
		{4,NO_DISTURB_RELAY_OFF_LED_OFF},
};
EmberEventControl kkSystemSetUpEventControl;
EmberEventControl kkUartMsgDelaySentEventControl;
EmberEventControl kEndpoint1DelayReportAttrEventControl;
EmberEventControl kEndpoint2DelayReportAttrEventControl;
EmberEventControl kEndpoint3DelayReportAttrEventControl;
EmberEventControl kEndpoint4DelayReportAttrEventControl;
EmberEventControl kDelaySetLedStatusEventControl;
EmberEventControl kRadarLedEventControl;
EmberEventControl kRadarCheckEventControl;
EmberEventControl kSyncStateWhenJoinSuccessEventControl;

SensorStatusSt g_stSensorStatusBuffer = {
	.mcu_version = 0,
	.status = 0x0,
};
#if defined(DUAL_LIGHT_PANEL)
	Endpoint_Desp sEndpoint_Desp[g_ucRelayTotalNum]= {{false,1,0xF1,false},{false,2,0xF2,false}};
#elif  defined(THREE_LIGHT_PANEL)
	Endpoint_Desp sEndpoint_Desp[g_ucRelayTotalNum]= {{false,1,0xF1,false},{false,2,0xF2,false},{false,3,0xF3,false}};
#elif  defined(FOUR_LIGHT_PANEL)
	Endpoint_Desp sEndpoint_Desp[g_ucRelayTotalNum]= {{false,1,0xF1,false},{false,2,0xF2,false},{false,3,0xF3,false},{false,4,0xF4,false}};
#endif
typedef enum {SCENES1=0xF1,SCENES2=0xF2,SCENES3=0xF3,SCENES4=0xF4}SCENES_STATUS;		//modify by zbw@200511
bool Human_body_induction_flag = false;
//ǿؿ״Ƿϱ־
static bool g_bIsNotKonkeGatewayFirstReportedFlg = false;
static uint8_t g_u8CurrentHeartEndpoint 		 = 1;
static bool g_bIsKeyLongPressCauseLeave 		 = false;
// BUTTONs CONFIG
BtnConfSt g_btnConfList[] = {
		{KEY_SYS_ID, KEY_SYS_PORT, KEY_SYS_PIN, EBP_HIGH, false, true, SYS_BUTTON_LONG_PRESS_TIME_MS},	// System Button
//		{RADAR_ID, RADAR_PORT, RADAR_PIN, EBP_HIGH, false, true, SENSOR_LONG_PRESS_TIME_MS},	// Radar
#ifdef SINGLE_LIGHT_PANEL
		{KEY1_ID, KEY2_PORT, KEY2_PIN, EBP_HIGH, false, false, 0xFFFFFF},
#endif
#ifdef	DUAL_LIGHT_PANEL
		{KEY1_ID, KEY3_PORT, KEY3_PIN, EBP_HIGH, false, false, 0xFFFFFF},	//
		{KEY2_ID, KEY4_PORT, KEY4_PIN, EBP_HIGH, false, false, 0xFFFFFF},	// Channel3
#endif
#ifdef THREE_LIGHT_PANEL
		{KEY1_ID, KEY1_PORT, KEY1_PIN, EBP_HIGH, false, false, 0xFFFFFF},	//
		{KEY2_ID, KEY2_PORT, KEY2_PIN, EBP_HIGH, false, false, 0xFFFFFF},	//
		{KEY3_ID, KEY3_PORT, KEY3_PIN, EBP_HIGH, false, false, 0xFFFFFF},	// Channel3
#endif
#ifdef FOUR_LIGHT_PANEL
		{KEY1_ID, KEY1_PORT, KEY1_PIN, EBP_HIGH, false, false, 0xFFFFFF},	//
		{KEY2_ID, KEY2_PORT, KEY2_PIN, EBP_HIGH, false, false, 0xFFFFFF},	//
		{KEY3_ID, KEY3_PORT, KEY3_PIN, EBP_HIGH, false, false, 0xFFFFFF},	//
		{KEY4_ID, KEY4_PORT, KEY4_PIN, EBP_HIGH, false, false, 0xFFFFFF},
#endif
};
// LEDs CONFIG
LedConfSt g_ledConfList[] = {
		{LED_RADAR_ID, 1, {LED_RADAR_PORT, LED_RADAR_PIN, PWM_UNKNOW_ID, PORT_UNKNOW, PIN_UNKNOW, PWM_UNKNOW_ID, PORT_UNKNOW, PIN_UNKNOW, PWM_UNKNOW_ID, PORT_UNKNOW, PIN_UNKNOW, PWM_UNKNOW_ID}, ELP_HIGH },
#ifdef SINGLE_LIGHT_PANEL
	{LED1_ID, 1, {LED2_PORT, LED2_PIN, PWM1_ID, PORT_UNKNOW, PIN_UNKNOW, PWM_UNKNOW_ID, PORT_UNKNOW, PIN_UNKNOW, PWM_UNKNOW_ID, PORT_UNKNOW, PIN_UNKNOW, PWM_UNKNOW_ID}, ELP_HIGH },	//
	{LED_ALL_ID, 1, {LED2_PORT, LED2_PIN, PWM1_ID, PORT_UNKNOW, PIN_UNKNOW, PWM_UNKNOW_ID, PORT_UNKNOW, PIN_UNKNOW, PWM_UNKNOW_ID, PORT_UNKNOW, PIN_UNKNOW, PWM_UNKNOW_ID}, ELP_HIGH  },	//all led by relay numbers
#endif
#ifdef	DUAL_LIGHT_PANEL
		{LED1_ID, 1, {LED3_PORT, LED3_PIN, PWM_UNKNOW_ID, PORT_UNKNOW,  PIN_UNKNOW, PWM_UNKNOW_ID, PORT_UNKNOW, PIN_UNKNOW, PWM_UNKNOW_ID, PORT_UNKNOW, PIN_UNKNOW, PWM_UNKNOW_ID}, ELP_HIGH},	//
		{LED2_ID, 1, {LED4_PORT, LED4_PIN, PWM_UNKNOW_ID, PORT_UNKNOW, PIN_UNKNOW, PWM_UNKNOW_ID, PORT_UNKNOW, PIN_UNKNOW, PWM_UNKNOW_ID, PORT_UNKNOW, PIN_UNKNOW, PWM_UNKNOW_ID}, ELP_HIGH },	//
		{LED_ALL_ID, 2, {LED3_PORT, LED3_PIN, PWM_UNKNOW_ID, LED4_PORT, LED4_PIN, PWM_UNKNOW_ID, PORT_UNKNOW, PIN_UNKNOW, PWM_UNKNOW_ID, PORT_UNKNOW, PIN_UNKNOW, PWM_UNKNOW_ID}, ELP_HIGH},	//all led by relay numbers
#endif
#ifdef THREE_LIGHT_PANEL
		{LED1_ID, 1, {LED1_PORT, LED1_PIN, PWM_UNKNOW_ID, PORT_UNKNOW,  PIN_UNKNOW, PWM_UNKNOW_ID, PORT_UNKNOW, PIN_UNKNOW, PWM_UNKNOW_ID, PORT_UNKNOW, PIN_UNKNOW, PWM_UNKNOW_ID}, ELP_HIGH},	//
		{LED2_ID, 1, {LED2_PORT, LED2_PIN, PWM_UNKNOW_ID, PORT_UNKNOW, PIN_UNKNOW, PWM_UNKNOW_ID, PORT_UNKNOW, PIN_UNKNOW, PWM_UNKNOW_ID, PORT_UNKNOW, PIN_UNKNOW, PWM_UNKNOW_ID}, ELP_HIGH },	//
		{LED3_ID, 1, {LED3_PORT, LED3_PIN, PWM_UNKNOW_ID, PORT_UNKNOW, PIN_UNKNOW, PWM_UNKNOW_ID, PORT_UNKNOW, PIN_UNKNOW, PWM_UNKNOW_ID, PORT_UNKNOW, PIN_UNKNOW, PWM_UNKNOW_ID}, ELP_HIGH },	//
		{LED_ALL_ID, 3, {LED1_PORT, LED1_PIN, PWM_UNKNOW_ID, LED2_PORT, LED2_PIN, PWM_UNKNOW_ID, LED3_PORT, LED3_PIN, PWM_UNKNOW_ID, PORT_UNKNOW, PIN_UNKNOW, PWM_UNKNOW_ID}, ELP_HIGH },	//all led by relay numbers
#endif
#ifdef FOUR_LIGHT_PANEL
		{LED1_ID, 1, {LED1_PORT, LED1_PIN, PWM_UNKNOW_ID, PORT_UNKNOW, PIN_UNKNOW, PWM_UNKNOW_ID, PORT_UNKNOW, PIN_UNKNOW, PWM_UNKNOW_ID, PORT_UNKNOW, PIN_UNKNOW, PWM_UNKNOW_ID}, ELP_HIGH},	//
		{LED2_ID, 1, {LED2_PORT, LED2_PIN, PWM_UNKNOW_ID, PORT_UNKNOW, PIN_UNKNOW, PWM_UNKNOW_ID, PORT_UNKNOW, PIN_UNKNOW, PWM_UNKNOW_ID, PORT_UNKNOW, PIN_UNKNOW, PWM_UNKNOW_ID}, ELP_HIGH },	//
		{LED3_ID, 1, {LED3_PORT, LED3_PIN, PWM_UNKNOW_ID, PORT_UNKNOW, PIN_UNKNOW, PWM_UNKNOW_ID, PORT_UNKNOW, PIN_UNKNOW, PWM_UNKNOW_ID, PORT_UNKNOW, PIN_UNKNOW, PWM_UNKNOW_ID}, ELP_HIGH },	//
		{LED4_ID, 1, {LED4_PORT, LED4_PIN, PWM_UNKNOW_ID, PORT_UNKNOW, PIN_UNKNOW, PWM_UNKNOW_ID, PORT_UNKNOW, PIN_UNKNOW, PWM_UNKNOW_ID, PORT_UNKNOW, PIN_UNKNOW, PWM_UNKNOW_ID}, ELP_HIGH },	//
		{LED_ALL_ID, 4, {LED1_PORT, LED1_PIN, PWM_UNKNOW_ID, LED2_PORT, LED2_PIN, PWM_UNKNOW_ID, LED3_PORT, LED3_PIN, PWM_UNKNOW_ID, LED4_PORT, LED4_PIN, PWM_UNKNOW_ID}, ELP_HIGH },	//all led by relay numbers
#endif
};


// ZERO-ACCESS CONFIG
RelayChannelConfSt g_relayConfList[] = {
	{RELAY_CHANNEL1_ID, 1, {RELAY1_PORT, RELAY1_PIN, PORT_UNKNOW, PIN_UNKNOW, PORT_UNKNOW, PIN_UNKNOW, PORT_UNKNOW, PIN_UNKNOW}, EZAP_HIGH },	// Channel1
	{RELAY_CHANNEL2_ID, 1, {RELAY2_PORT, RELAY2_PIN, PORT_UNKNOW, PIN_UNKNOW, PORT_UNKNOW, PIN_UNKNOW, PORT_UNKNOW, PIN_UNKNOW}, EZAP_HIGH },	// Channel2
	{RELAY_CHANNEL3_ID, 1, {RELAY3_PORT, RELAY3_PIN, PORT_UNKNOW, PIN_UNKNOW, PORT_UNKNOW, PIN_UNKNOW, PORT_UNKNOW, PIN_UNKNOW}, EZAP_HIGH },	// Channel3
	{RELAY_CHANNEL4_ID, 1, {RELAY4_PORT, RELAY4_PIN, PORT_UNKNOW, PIN_UNKNOW, PORT_UNKNOW, PIN_UNKNOW, PORT_UNKNOW, PIN_UNKNOW}, EZAP_HIGH },	// Channel3
	{RELAY_ALL_ID, 4, {RELAY1_PORT, RELAY1_PIN, RELAY2_PORT, RELAY2_PIN, RELAY3_PORT, RELAY3_PIN, RELAY4_PORT, RELAY4_PIN}, EZAP_HIGH },	//ALL
};

PwmConfSt g_pwmConfList[] = {
#ifdef SINGLE_LIGHT_PANEL
	{PWM1_ID, {LED2_PORT, LED2_PIN, KTIMER0, KK_TIMER_CC1}},	//
#endif
#ifdef	DUAL_LIGHT_PANEL
	{PWM1_ID, {LED2_PORT, LED2_PIN, KTIMER0, KK_TIMER_CC0}},	//
	{PWM2_ID, {LED4_PORT, LED4_PIN, KTIMER0, KK_TIMER_CC1}},	//
#endif
#ifdef THREE_LIGHT_PANEL
	{PWM1_ID, {LED1_PORT, LED1_PIN, KTIMER0, KK_TIMER_CC0}},	//
	{PWM2_ID, {LED2_PORT, LED2_PIN, KTIMER0, KK_TIMER_CC1}},	//
	{PWM3_ID, {LED3_PORT, LED3_PIN, KTIMER0, KK_TIMER_CC2}},	//
#endif
#ifdef FOUR_LIGHT_PANEL
	{PWM1_ID, {LED1_PORT, LED1_PIN, KTIMER0, KK_TIMER_CC0}},	//
	{PWM2_ID, {LED2_PORT, LED2_PIN, KTIMER0, KK_TIMER_CC1}},	//
	{PWM3_ID, {LED3_PORT, LED3_PIN, KTIMER0, KK_TIMER_CC2}},	//
	{PWM4_ID, {LED4_PORT, LED4_PIN, KTIMER1, KK_TIMER_CC0}},
#endif
};

//ϻ
FactoryTestConfSt g_factoryTestConfList[] = {
		{KEY_SYS_ID, LONG_PRESS_1_TIMES, MECHANICAL_KEY_LONG_PRESS_TIME_MS},
};
//first cluster as main cluster heartbeat to report,
BindObjSt cluster_obj_list[] = {
#ifdef SINGLE_LIGHT_PANEL
		{ZCL_ON_OFF_CLUSTER_ID, ZCL_ON_OFF_ATTRIBUTE_ID,  1},
#endif
#ifdef	DUAL_LIGHT_PANEL
		{ZCL_ON_OFF_CLUSTER_ID, ZCL_ON_OFF_ATTRIBUTE_ID,  1},
		{ZCL_ON_OFF_CLUSTER_ID, ZCL_ON_OFF_ATTRIBUTE_ID,  2},
#endif
#ifdef THREE_LIGHT_PANEL
		{ZCL_ON_OFF_CLUSTER_ID, ZCL_ON_OFF_ATTRIBUTE_ID,  1},
		{ZCL_ON_OFF_CLUSTER_ID, ZCL_ON_OFF_ATTRIBUTE_ID,  2},
		{ZCL_ON_OFF_CLUSTER_ID, ZCL_ON_OFF_ATTRIBUTE_ID,  3},
#endif
#ifdef FOUR_LIGHT_PANEL
		{ZCL_ON_OFF_CLUSTER_ID, ZCL_ON_OFF_ATTRIBUTE_ID,  1},
		{ZCL_ON_OFF_CLUSTER_ID, ZCL_ON_OFF_ATTRIBUTE_ID,  2},
		{ZCL_ON_OFF_CLUSTER_ID, ZCL_ON_OFF_ATTRIBUTE_ID,  3},
		{ZCL_ON_OFF_CLUSTER_ID, ZCL_ON_OFF_ATTRIBUTE_ID,  4},
#endif
		{ZCL_DIAGNOSTICS_CLUSTER_ID, ZCL_LAST_MESSAGE_RSSI_ATTRIBUTE_ID,  1},
};

static uint8_t g_ucRelayIdBuff[] = {RELAY_CHANNEL1_ID, RELAY_CHANNEL2_ID, RELAY_CHANNEL3_ID, RELAY_CHANNEL4_ID, RELAY_ALL_ID};
static bool power_on_sync[4] = {false,false,false,false};
#define GET_MAX_ENDPOINT(relay_num)  (relay_num)
#define GET_LED_ID(endpoint) (endpoint == 1?LED1_ID:(endpoint == 2?LED2_ID:(endpoint == 3?LED3_ID:LED4_ID)))
#define GET_ENDPOINT(led_id) (led_id == LED1_ID?1:(led_id == LED2_ID?2:(led_id == LED3_ID?3:4)))
//#define GET_LED_ID(endpoint, max_point) (endpoint == 1?LED1_ID:(endpoint == 2?(max_point == 2?LED2_ID:LED2_ID):LED3_ID))
#define GET_LED_ID_BY_ENDPOINT(endpoint, max_endpint) (endpoint <= max_endpint?GET_LED_ID(endpoint):LED_UNKNOW_ID)

void kRadarLedEventHandler(void);
void JoinCompleteCallback(NwkJoinCompltEnum nwkcomplt );
void kUserScheduleTaskHandlerCallback(uint8_t schedule_id );
void kUserButtonAcitonCallback(unsigned char button_id, BtnActionEnum action );
void kUserNetworkStatusNotify(NwkStatusEnum nwkst );
void kUserOnOffClusterOnOffStatusCallback(uint8_t endpoint, OnOffStatusEnum estatus );
void kUserRelayLedCallback(RelayStatusSt status);
void kZclClusterRecallSceneCallback(uint8_t endpoint,  uint16_t cluster, uint8_t command_id
		, bool reportEnable, bool sceneRecallFlg, bool reportGatewayEnable, bool reportChildDeviceEnable);
void kUserLedActionDoneCallback(unsigned char id);
void kUserFactorTestPollCallback(FactoryTestStatusEnum status);
void kOTAMoudleUserCallback(OTAStatusEnum status);
void kUserPwmActionDoneCallback(unsigned char id, PwmGradientDirectionEnum opt);
void kUserNetworkExitCompleteCallback(void);
//void kIasZoneSensorChangedStatusReport(bool ir_sensor_status, bool tamper_switch_status);
kk_err_t kUserOODMessageIncoming(uint8_t channel, uint8_t opcode, uint8_t args_in_out[], uint8_t *length_in_out );
void kSetIndicatorNotDisturbModeFlg(bool status);
bool kGetIndicatorNotDisturbModeFlg(void);

static void kSetLedStatus(LED_ID_ENUM id);  //otaʧܻɹʧܺɫͰɫled
static bool kEndpointIsValid(uint8_t endpoint);
static void kLEDOffAction(LED_ID_ENUM led_id);
static bool kClustePeriodReportCheckIsSet(uint8_t endpoint); //жreportʱǷù
Endpoint_Desp* kGetBindConfigInfo(void);
void kSetBindConfigInfo(Endpoint_Desp* info);
void Operate_LED_Action(LED_ID_ENUM LED_Id);
void Control_Relay(KEY_ID_ENUM Key_ID);
void Scense_Operation(uint8_t id);
void kZclSceneRecall(uint8_t srcEndpoint, uint16_t groupId, uint8_t sceneId, uint16_t time);
uint8_t  Get_Binding_Relay_By_KeyID(KEY_ID_ENUM KeyID);
kk_err_t kOptKeyStateReport(uint8_t KeyID,uint8_t Relay_ID,uint8_t Relay_State);
uint8_t Find_Endpoint_ID_By_Key_ID(KEY_ID_ENUM Key_ID);
void Reset_Save_Token_Data(void)
{
	for(uint8_t i = 0;i<g_ucRelayTotalNum;i++)
	{
		sEndpoint_Desp[i].mode 	  			= false;
		sEndpoint_Desp[i].Relay_ID   		= 1+i;
		sEndpoint_Desp[i].Scense_ID   		= 0xF1+i;
		sEndpoint_Desp[i].IsHengDa_Gateway  = false;
	}
	kSetBindConfigInfo(sEndpoint_Desp);
}
/** @brief Main Init
 *
 * This function is called from the application's main function. It gives the
 * application a chance to do any initialization required at system startup. Any
 * code that you would normally put into the top of the application's main()
 * routine should be put into this function. This is called before the clusters,
 * plugins, and the network are initialized so some functionality is not yet
 * available.
        Note: No callback in the Application Framework is
 * associated with resource cleanup. If you are implementing your application on
 * a Unix host where resource cleanup is a consideration, we expect that you
 * will use the standard Posix system calls, including the use of atexit() and
 * handlers for signals such as SIGTERM, SIGINT, SIGCHLD, SIGPIPE and so on. If
 * you use the signal() function to register your signal handler, please mind
 * the returned value which may be an Application Framework function. If the
 * return value is non-null, please make sure that you call the returned
 * function from your handler to avoid negating the resource cleanup of the
 * Application Framework itself.
 *
 */
void emberAfMainInitCallback(void)
{
	emberAfOtaStorageClearTempDataCallback();
#if 1
	UserModuleInit();
#endif
}
#if 0
/** @brief Called whenever the GPIO sensor detects a change in state.
 *
 * @param newSensorState The new state of the sensor based alarm
 * (EMBER_AF_PLUGIN_GPIO_SENSOR_ACTIVE or
 * EMBER_AF_PLUGIN_GPIO_SENSOR_NOT_ACTIVE)  Ver.: always
 */
void emberAfPluginGpioSensorStateChangedCallback(uint8_t newSensorState)
{
	iKonkeAfSelfPrint("Sensor Status(%d)", newSensorState);
	//𿪹ش
	kIasZoneSensorChangedStatusReport(false,newSensorState?true:false);
}
#endif

/*	DESP: User Module init interface.
 * 	Auth: dingmz_frc.20190623.
 * */
void UserModuleInit(void )
{
	kk_err_t err = KET_OK;

	iKonkeAfSelfPrint("\r\n************************************************\r\n");
	iKonkeAfSelfPrint("xxx Reboot Reason: R-INFO(0x%x: %p), R-EXTEND(0x%x: %p) xxx\r\n"
		, halGetResetInfo(), halGetResetString()
		, halGetExtendedResetInfo(), halGetExtendedResetString());
	iKonkeAfSelfPrint("xxx Network Status: %d, systime: %d xxx\r\n", emberAfNetworkState()
		, halCommonGetInt32uMillisecondTick());
//	unsigned char temp_length = 0;
//	char temp_string[OPTTUNNEL_CMEI_MAXLEN] = { 0 };
//	kOptTunnelAttrChunkLocalWrite(ECA_CMEI, "1212121255", 10);
//	kOptTunnelAttrChunkLocalWrite(ECA_ISN, "23232366778", 10);
//
//	kOptTunnelAttrChunkLocalRead(ECA_CMEI, (unsigned char *)temp_string, &temp_length);
//	iKonkeAfSelfPrint("CMEI length(%d):\r\n", temp_length);
//	iKonkeAfSelfPrintBuffer(temp_string,temp_length, true );
//	kOptTunnelAttrChunkLocalRead(ECA_ISN, (unsigned char *)temp_string, &temp_length);
//	iKonkeAfSelfPrint("ISN length(%d):\r\n", temp_length);
//	iKonkeAfSelfPrintBuffer(temp_string,temp_length, true );
//	kOptTunnelAttrChunkLocalRead(ECA_INSTALL_CODE, (unsigned char *)temp_string, &temp_length);
//	iKonkeAfSelfPrint("ECA_INSTALL_CODE length(%d):\r\n", temp_length);
//	iKonkeAfSelfPrintBuffer(temp_string,temp_length, true );
	iKonkeAfSelfPrint("\r\n************************************************\r\n");

	
#if 1
	// init the led driver.
	//LED_InitHard(gpioPortB, 0);

	// Init the wakeup out pin, for wakeup MCU
	//GPIO_PinModeSet(g_eWakeupOutPortSelected, g_iWakeupOutPinSelected, gpioModePushPull, 1);
	err = kBtnModuleInit(g_btnConfList, sizeof(g_btnConfList) / sizeof(BtnConfSt), kUserButtonAcitonCallback);

	if( err != KET_OK ) {
		iKonkeAfSelfPrint("Err: Button Module Init failed(%d)!!\r\n", err);
	}
#if 0
	err = kPwmModuleInit(g_pwmConfList, sizeof(g_pwmConfList)/sizeof(PwmConfSt), kUserPwmActionDoneCallback);
	if( err != KET_OK ) {
		iKonkeAfSelfPrint("Err: PWM Module Init failed(%d)!!\r\n", err);
	}
#endif
	err = kLedModuleInit(g_ledConfList, sizeof(g_ledConfList) / sizeof(LedConfSt), kUserLedActionDoneCallback);
	if( err != KET_OK ) {
		iKonkeAfSelfPrint("Err: Led Module Init failed(%d)!!\r\n", err);
	}

	//Init battery ADC sample
	//kBatteryMonitorInit();
	//ļ̵ҲԳʼ ZERO_PORTΪPORT_UNKNOW
	err = kRelayModuleInit(ZERO_PORT, ZERO_PIN, CHECKED_ZERO_DELAY_ON_TIME_MS, CHECKED_ZERO_DELAY_OFF_TIME_MS \
			, EZAP_LOW, g_relayConfList,  sizeof(g_relayConfList)/sizeof(RelayChannelConfSt), kUserRelayLedCallback);
	if( err != KET_OK ) {
		iKonkeAfSelfPrint("Err: Zero-Access Module Init failed(%d)!!\r\n", err);
	}

	kNwkModuleInit(cluster_obj_list, sizeof(cluster_obj_list) / sizeof(BindObjSt), kUserNetworkStatusNotify \
					, kUserNetworkExitCompleteCallback, NWK_STEERING_TIMEOUT_MS, LED_UNKNOW_ID, BTN_UNKNOW_ID);

	GPIO_PinModeSet(RADAR_PORT, RADAR_PIN, gpioModeInputPull, 0);
	// ZCL
	kZclOnOffClusterServerInit(kUserOnOffClusterOnOffStatusCallback);
	//kZclOTAClusterClientInit(1);
	kZclClusterSceneRecallCallbackInit(kZclClusterRecallSceneCallback);
	//emberEventControlSetActive(kRadarCheckEventControl);

	// init the private cluster protocol module.
	kOptTunnelModuleInit(kUserOODMessageIncoming);

	//kkPollProceduleTrigger(5, true);

#if 1
	kNwkScheduleTaskRegister(1,  HEARTBEAT_TIME_MS, kUserScheduleTaskHandlerCallback);
	//kNwkScheduleTaskRegister(2, 3600000UL, kUserScheduleTaskHandlerCallback);
	//kNwkScheduleTaskRegister(3,  5000, kUserScheduleTaskHandlerCallback);
	//kNwkScheduleTaskRegister(4, 10000, kUserScheduleTaskHandlerCallback);
#endif

#if 0 // Just for debug
	kOptTunnelAttrChunkLocalWrite((unsigned char *)"CCCMCINC", strlen("CCCMCINC") + 1, ECA_CMEI);
	kOptTunnelAttrChunkLocalWrite((unsigned char *)"IIISS090IOOJO", strlen("IIISS090IOOJO") + 1, ECA_ISN);
	memset(cmei_string, 0, sizeof(cmei_string));
	memset(isn_string, 0, sizeof(isn_string));
	kOptTunnelAttrChunkLocalRead((unsigned char *)cmei_string, &temp_length, ECA_CMEI);
	iKonkeAfSelfPrint("CMEI: %s,\r\n", cmei_string);
	kOptTunnelAttrChunkLocalRead((unsigned char *)isn_string , &temp_length, ECA_ISN );
	iKonkeAfSelfPrint("ISN: %s,\r\n", isn_string);
#endif

	emberEventControlSetDelayMS(kkSystemSetUpEventControl, BOOT_DONE_TIME_MS);
	//emberEventControlSetInactive(kkUartMsgDelaySentEventControl);

	GPIO_DbgSWOEnable(false);

	kCmdCommandConsoleModuleInit();
#if Z30_DEVICE_OTA_ENABLE
	kOTAMoudleInit(kOTAMoudleUserCallback, LED_ALL_ID);
#endif
#if Z30_DEVICE_AGING_ENABLE
	kFactoryTestInit(kUserFactorTestPollCallback, g_factoryTestConfList, sizeof(g_factoryTestConfList)/ sizeof(FactoryTestConfSt));
#endif
	//kTimer3OneShotStart(7000, NULL);
	//kTimer3Init(1000);
#endif
	//add by maozj 20200608
	kOptTunnelTrytoWriteInstallCode();
	
	EmberAfOtaImageId GetInfo;
	uint16_t hard_version;
	emberAfOtaClientVersionInfoCallback(&GetInfo,&hard_version);
	iKonkeAfSelfPrint("Get Ota Image ID = %d: MFG Code = %2x,hardversion = %2x\r\n", GetInfo.firmwareVersion,GetInfo.manufacturerId,hard_version);
}

void kUserNetworkStatusNotify(NwkStatusEnum nwkst )
{
	iKonkeAfSelfPrint("#############################kUserNetworkStatusNotify = %d\r\n", nwkst);
	//static NwkStatusEnum lastStatus = ENS_UNKNOW;
	switch(nwkst) {
		case (ENS_OFFLINE):
		{
			//LED_OPT_OFF(NWK_LED_ID);
			break;
		}
		case (ENS_ONLINE ):
		{
			uint32_t randTimeMS = DELAY_REPORT_DATA_AFTER_NWK_JOINED_MS;
			//power on after joined network
			uint64_t currentTimeMS = halCommonGetInt64uMillisecondTick();
			if ( currentTimeMS < MIN_JOINED_NWK_DELAY_TIME_MS){
				randTimeMS = kUtilsGetRandNum(RAND_MIN_NUM, RAND_MAX_NUM);
			}else {
				//ϵλɫ˸ر
				//kLedOptTrigger(LED_ALL_ID, 0, 0, 0, LED_OFF, LED_IGNORE);
			}
			kSetLedStatus(LED_ALL_ID);
			iKonkeAfSelfPrint("Joined Network RandTime(%dms) CurrentTime(%ld)\r\n", randTimeMS, currentTimeMS);
			g_u8CurrentHeartEndpoint = 1;
			if (kIsKonkeRemoteGateway() != true){
				g_bIsNotKonkeGatewayFirstReportedFlg = false;
				//report heartbeat data
				kNwkScheduleTaskRegister(1,  randTimeMS, kUserScheduleTaskHandlerCallback);
			}
			emberEventControlSetDelayMS(kSyncStateWhenJoinSuccessEventControl,100);
			//kkPollProceduleTrigger(10, true);
			#if(Z30_DEVICE_DTYPE == Z30_DEVICE_ZED_SLEEPY)
//			LED_OPT_OFF(LED_SYS_ID);
			#else

			#endif
			break;
		}
		case (ENS_JOINING):
		{
//			LED_OPT_OFF(LED_SYS_ID);
			kLedOptTrigger(LED_ALL_ID, LED_FAST_BLINK_ON_TIME_MS, LED_FAST_BLINK_OFF_TIME_MS, \
					LED_SLOW_BLINK_CONTINUE_TIME_MS/(LED_FAST_BLINK_ON_TIME_MS+LED_FAST_BLINK_ON_TIME_MS), LED_ON, LED_IGNORE);
			break;
		}
		case (ENS_LEAVED):
		{
			iKonkeAfSelfPrint("#####Enter Leave\r\n");
			Reset_Save_Token_Data();
			bool bIsAllOffFlg = true;
			for (uint8_t i = 1; i <= GET_MAX_ENDPOINT(g_ucRelayTotalNum); i++){
				if (kZclOnOffClusterServerOnOffGet(i) == EOOS_ON){
					bIsAllOffFlg = false;
					break;
				}
			}
			if(!bIsAllOffFlg)
			{
				iKonkeAfSelfPrint("Enter Leave current state = %d\r\n", kNwkGetCurrentStatus());
				//if(kNwkGetCurrentStatus() == ENS_LEAVED){
					kNwkFactoryReset(false);
					//steering timeout can be set
					iKonkeAfSelfPrint("#####Start Steering\r\n");
					kNwkJoiningStart(NWK_STEERING_TIMEOUT_MS, JoinCompleteCallback);
				//}
			}
			//رջɫLED
//			LED_OPT_OFF(LED_SYS_ID);
//			kLedOptTrigger(LED_ALL_ID, LED_FAST_BLINK_ON_TIME_MS, LED_FAST_BLINK_OFF_TIME_MS, \
//									LED_FAST_BLINK_CONTINUE_TIME_MS/(LED_FAST_BLINK_ON_TIME_MS+LED_FAST_BLINK_OFF_TIME_MS), LED_ON, LED_OFF);
			//network leave open led blink when humanbody exist
			//رģʽ
			//kSetIndicatorNotDisturbModeFlg(false);

			//kZclOnOffClusterServerOnOffControl(1, kZclOnOffClusterServerOnOffGet(1));
			//kZclOnOffClusterServerOnOffControl(2, kZclOnOffClusterServerOnOffGet(2));
			//kZclOnOffClusterServerOnOffControl(3, kZclOnOffClusterServerOnOffGet(3));
			break;
		}
		default:
		{
//			LED_OPT_OFF(LED_SYS_ID);
			break;
		}
	}
	//lastStatus = nwkst;
}

//صԴ̰˫ģע˰ID,IDİͲҪﴦ
void kUserButtonAcitonCallback(unsigned char button_id, BtnActionEnum action )
{
	iKonkeAfSelfPrint("kUserButton: ButtonId(%d), Action(%d) NWK(%d)\r\n", button_id, action, emberAfNetworkState());

	kOptTunneCheckNodeIdIsChangedReport();

	if ( kGetFactoryTestStatus() == FTS_AGING_8HOU || kGetFactoryTestStatus() == FTS_AGING_DONE \
			|| kGetFactoryTestStatus() == FTS_AGING_WAITING \
			|| kGetFactoryTestStatus() == FTS_AGING_WAITING_SECOND_PRESS \
			|| kNwkIsExiting() == true){
		//δϻɣ̵
		return;
	}
	if((button_id == KEY1_ID)||(button_id == KEY2_ID)||(button_id == KEY3_ID)||(button_id == KEY4_ID))
	{
		if(action == EBA_CLICK)
		{
			uint8_t endpoint = Find_Endpoint_ID_By_Key_ID(button_id);
			uint8_t currentValue ;
			emberAfReadServerAttribute(endpoint,ZCL_ON_OFF_CLUSTER_ID,ZCL_ON_OFF_ATTRIBUTE_ID,
					(uint8_t *)&currentValue,sizeof(currentValue));
			currentValue = 1-currentValue;
			if((sEndpoint_Desp[0].IsHengDa_Gateway)&&(!sEndpoint_Desp[button_id-2].mode))
				kOptKeyStateReport(button_id-1,endpoint,currentValue);
		}
	}
	switch(button_id) {
#if 1
		case (KEY_SYS_ID):
		{
			//ϻʱϵͳЧ
//			if ( kGetFactoryTestStatus() != FTS_NORMAL){
//				return;
//			}
			switch(action) {
				case (EBA_CLICK):
				{
					for(uint8_t j=0;j<4;j++)
					{
						iKonkeAfSelfPrint("#####sEndpoint_Info,mode(%d),Relay_id(%d),Scense ID(%d)\r\n",
						 sEndpoint_Desp[j].mode,sEndpoint_Desp[j].Relay_ID,sEndpoint_Desp[j].Scense_ID);
					}
					iKonkeAfSelfPrint("#####IS HengDa Gateway= %d\r\n",sEndpoint_Desp[0].IsHengDa_Gateway);
					if (kNwkIsExiting() == true){
						iKonkeAfSelfPrint("#####NWK is exiting\r\n");
						return;
					}

					if( kNwkGetCurrentStatus() == ENS_ONLINE ) { // report connected!
						iKonkeAfSelfPrint("#####Report Connected\r\n");
						//kNwkNetworkStatusIndicator(ELS_INDI_ONLINE);
						if  (kLedIsBlinking(LED_ALL_ID) != true){
							kLedOptTrigger(LED_ALL_ID,  LED_FAST_BLINK_ON_TIME_MS, LED_FAST_BLINK_OFF_TIME_MS, 1, LED_ON, LED_OFF);
						}
						if (kIsKonkeRemoteGateway() == true){
							// report connected
							kOptTunnelOODReport(0, 0XCD, NULL, 0);
						}
					}

					break;
				}
				case (EBA_LONGPRESS):
				{
					//رջɫLED
//					LED_OPT_OFF(LED_SYS_ID);
					bool status = false;
					g_bIsKeyLongPressCauseLeave = true;
					if (kNwkGetCurrentStatus() == ENS_ONLINE || kNwkGetCurrentStatus() == ENS_OFFLINE){
						status = true;
						if(kNwkGetCurrentStatus() != ENS_JOINING)
							kNwkFactoryReset(status);
					}else if(kNwkGetCurrentStatus() == ENS_LEAVED){
						kNwkFactoryReset(false);
						//steering timeout can be set
						iKonkeAfSelfPrint("#####Start Steering\r\n");
						kNwkJoiningStart(NWK_STEERING_TIMEOUT_MS, JoinCompleteCallback);
					}
					break;
				}
				default: break;
			}

			break;
		}
#endif
		case (KEY1_ID):
		{
			if (action == EBA_CLICK){
				if(sEndpoint_Desp[0].mode){
					Scense_Operation(0);
				}
				else{
					Control_Relay(KEY1_ID);
				}
				iKonkeAfSelfPrint("Warning: KEY1_ID press,mode =%d\r\n",sEndpoint_Desp[0].mode);
			}
			break;
		}
		case (KEY2_ID):
		{
			if (g_ucRelayTotalNum < 2){
				iKonkeAfSelfPrint("Warning: KEY2_ID is unused\r\n");
				return;
			}

			if (action == EBA_CLICK){
				if(sEndpoint_Desp[1].mode){
					Scense_Operation(1);
				}
				else{
					Control_Relay(KEY2_ID);
				}
				iKonkeAfSelfPrint("Warning: KEY2_ID press,mode = %d\r\n",sEndpoint_Desp[1].mode);
			}
			break;
		}
		case (KEY3_ID):
		{
			if (g_ucRelayTotalNum < 3){
				iKonkeAfSelfPrint("Warning: KEY3_ID is unused\r\n");
				return;
			}

			if (action == EBA_CLICK){
				if(sEndpoint_Desp[2].mode){
					Scense_Operation(2);
				}
				else{
					Control_Relay(KEY3_ID);
				}
				iKonkeAfSelfPrint("Warning: KEY3_ID press,mode = %d\r\n",sEndpoint_Desp[2].mode);
			}
			break;
		}
		case (KEY4_ID):
		{
			if (g_ucRelayTotalNum < 4){
				iKonkeAfSelfPrint("Warning: KEY4_ID is unused\r\n");
				return;
			}

			if (action == EBA_CLICK){
				if(sEndpoint_Desp[3].mode){
					Scense_Operation(3);
				}
				else{
					Control_Relay(KEY4_ID);
				}
				iKonkeAfSelfPrint("Warning: KEY4_ID press,mode = %d\r\n",sEndpoint_Desp[3].mode);
			}
			break;
		}

		default: break;
	}
}

//add by zbw
#if 0
void kUserPwmActionDoneCallback(unsigned char id, PwmGradientDirectionEnum opt)
{
	switch(id)
	{
		case PWM1_ID:
			kSetLedStatus(LED1_ID);
			break;
		case PWM2_ID:
			kSetLedStatus(LED2_ID);
			break;
		case PWM3_ID:
			kSetLedStatus(LED3_ID);
			break;
		case PWM4_ID:
			kSetLedStatus(LED4_ID);
			break;
		default:
			break;
	}

}
#endif
//on off ԸıĻصһ̵⣬ûйͬLED״̬
void kUserOnOffClusterOnOffStatusCallback(uint8_t endpoint, OnOffStatusEnum estatus )
{
	iKonkeAfSelfPrint("OnOff-status: endpoint(%d), estatus(%d)\r\n", endpoint, estatus);

	emberEventControlSetActive(kRadarLedEventControl);

	ZclReportTableSt zclReportInfo;
	bool status = kZclClusterGetPermitReportInfo(endpoint,&zclReportInfo);
	if (status == true){
		//ϵ󲻴̵ָ״̬ߺΪfalseҲ
		if (zclReportInfo.reportEnable != true && zclReportInfo.sceneRecallFlg != true){
			iKonkeAfSelfPrint("ENDPOINT(%d) report is unable\r\n", zclReportInfo.endpoint);
			return;
		}
	}

	switch(endpoint) {
		case (1):
		{
			kRelayChannelOpt(RELAY_CHANNEL1_ID,estatus == EOOS_OFF? EZAO_OFF : EZAO_ON);

			break;
		}
		case (2):
		{
			kRelayChannelOpt(RELAY_CHANNEL2_ID,estatus == EOOS_OFF? EZAO_OFF : EZAO_ON);

			break;
		}
		case (3):
		{
			kRelayChannelOpt(RELAY_CHANNEL3_ID,estatus == EOOS_OFF? EZAO_OFF : EZAO_ON);

			break;
		}
		case (4):
		{
			kRelayChannelOpt(RELAY_CHANNEL4_ID,estatus == EOOS_OFF? EZAO_OFF : EZAO_ON);
			break;
		}
		default: break;
	}


}
//̵ɣͬLED״̬ǹ̵ҲǵLED
void kUserRelayLedCallback(RelayStatusSt status)
{
	iKonkeAfSelfPrint("#########kUserZaLedCallback channel(%d) opt(%d)\r\n", status.u8RelayChannelId, status.opt);

	if (kLedIsBlinking(LED_ALL_ID) == true || kNwkGetCurrentStatus() == ENS_JOINING)
	{
		return;
	}
#if 0
	switch (status.u8RelayChannelId)
	{
		case RELAY_CHANNEL1_ID:
			if (kNwkGetCurrentStatus() == ENS_ONLINE || power_on_sync[0] == true \
					|| kGetFactoryTestStatus() == FTS_AGING_8HOU 	\
					|| kGetFactoryTestStatus() == FTS_AGING_DONE 	\
					|| kGetFactoryTestStatus() == FTS_AGING_WAITING 	\
					|| kGetFactoryTestStatus() == FTS_AGING_WAITING_SECOND_PRESS){
				power_on_sync[0] = false;
			//TODO
			}else if (kNwkGetCurrentStatus() == ENS_LEAVED \
					|| kNwkGetCurrentStatus() == ENS_OFFLINE){

			}
			break;
		case RELAY_CHANNEL2_ID:
			if (kNwkGetCurrentStatus() == ENS_ONLINE || power_on_sync[1] == true \
					|| kGetFactoryTestStatus() == FTS_AGING_8HOU 	\
					|| kGetFactoryTestStatus() == FTS_AGING_DONE 	\
					|| kGetFactoryTestStatus() == FTS_AGING_WAITING 	\
					|| kGetFactoryTestStatus() == FTS_AGING_WAITING_SECOND_PRESS){
				power_on_sync[1] = false;
				if (status.opt == EZAO_OFF){
					kLEDOffAction(LED2_ID);
				}else if (status.opt == EZAO_ON){
					LED_OPT_ON(LED2_ID);
				}
			}else if (kNwkGetCurrentStatus() == ENS_LEAVED \
					|| kNwkGetCurrentStatus() == ENS_OFFLINE){
			}
			break;
		case RELAY_CHANNEL3_ID:
			if (kNwkGetCurrentStatus() == ENS_ONLINE || power_on_sync[2] == true \
					|| kGetFactoryTestStatus() == FTS_AGING_8HOU 	\
					|| kGetFactoryTestStatus() == FTS_AGING_DONE 	\
					|| kGetFactoryTestStatus() == FTS_AGING_WAITING 	\
					|| kGetFactoryTestStatus() == FTS_AGING_WAITING_SECOND_PRESS){

			}else if (kNwkGetCurrentStatus() == ENS_LEAVED \
					|| kNwkGetCurrentStatus() == ENS_OFFLINE){

			}
			break;
		case RELAY_CHANNEL4_ID:
			if (kNwkGetCurrentStatus() == ENS_ONLINE || power_on_sync[3] == true \
					|| kGetFactoryTestStatus() == FTS_AGING_8HOU 	\
					|| kGetFactoryTestStatus() == FTS_AGING_DONE 	\
					|| kGetFactoryTestStatus() == FTS_AGING_WAITING 	\
					|| kGetFactoryTestStatus() == FTS_AGING_WAITING_SECOND_PRESS){
				power_on_sync[3] = false;
			}else if (kNwkGetCurrentStatus() == ENS_LEAVED \
					|| kNwkGetCurrentStatus() == ENS_OFFLINE){
			}
			break;

		default:
			iKonkeAfSelfPrint("###Erro: Relay Channel is invalid\r\n");
			break;
	}
#endif
}
#if 1
void JoinCompleteCallback(NwkJoinCompltEnum nwkcomplt )
{
	iKonkeAfSelfPrint("#########JoinCompleteCallback = %d\r\n", nwkcomplt);
	switch(nwkcomplt) {
		case (EJC_JOIN_FAILED ):
		{
			//kLedOptTrigger(1, 100, 100,  6, LED_ON, LED_OFF);
			kSetLedStatus(LED_ALL_ID);
			uint8_t  data = 1;
			halCommonSetToken(TOKEN_JOIN_FAILED_FLAG, &data);
			kUserNetworkExitCompleteCallback();
			break;
		}
		case (EJC_JOIN_SUCCEED):
		{
			#if (Z30_DEVICE_DTYPE == Z30_DEVICE_ZED_SLEEPY)
			//ɹָʾϨ
			//LED_OPT_OFF(LED_ALL_ID);
			#else
			//LED_OPT_ON(LED_ALL_ID);
			#endif
			break;
		}
		case (EJC_CONNLINK_OK ):
		{
			//kNwkjoinSucceedProcedureTrigger(3000);
			break;
		}
		default: break;
	}
}
#endif

void kSetIndicatorNotDisturbModeFlg(bool status)
{
	halCommonSetToken(TOKEN_INDICATOR_NOT_DISTURB_MODE_FLG, &status);
}

bool kGetIndicatorNotDisturbModeFlg(void)
{
	bool status = false;
	halCommonGetToken(&status, TOKEN_INDICATOR_NOT_DISTURB_MODE_FLG);
	return status;
}
#ifdef ZCL_USING_IAS_ZONE_CLUSTER_SERVER
void kIasZoneSensorChangedStatusReport(bool ir_sensor_status, bool tamper_switch_status)
{
	static uint64_t lastTimeMS = 0;
	static uint64_t lastPreventTimeMS = 0;
	uint64_t currentTimeMS = halCommonGetInt64uMillisecondTick();
	uint64_t timeDiffMS = currentTimeMS - lastTimeMS;
	uint64_t preventTimeDiffMS =  currentTimeMS - lastPreventTimeMS;

	//iKonkeAfSelfPrint("IAS Sensor lastTimeMs(%d) currentTimeMs(%d) diffMs(%d)\r\n",lastTimeMS, currentTimeMS, timeDiffMS);
	IasZoneStatusBitEnum bit = BIT_INIT;

	if (tamper_switch_status){
		bit = TAMPER;
	}

	uint8_t status = bit?(1<<bit):0;
	//ϱӦʱ𿪹״̬ϱ𿪹״̬ʱӦ״̬
	if (ir_sensor_status == true){
		if (kGetBatteryVoltageMilliV()  <= BATTERY_LOWPOWER_LIMIT_VAL_MV){
			iKonkeAfSelfPrint("Battery Low Power\r\n");
			return;
		}

		//ʱ͵紫źţ⴫͵ѹλ󴥷
		if (kkGetPreventSensorFlg() == true && preventTimeDiffMS > IR_SENSOR_LOCK_TIME_MS / 2){
			kkClearPreventSensorFlg();
			iKonkeAfSelfPrint("Prevent Sensor Flag Clear\r\n");
		}else if (kkGetPreventSensorFlg() == true){
			iKonkeAfSelfPrint("Prevent Sensor Flag is true\r\n");
			return;
		}

		//15S lock time. also delay 10S if sensor reset when sensor wakeup
		if (((timeDiffMS > IR_SENSOR_LOCK_TIME_MS)  || (lastTimeMS == 0 && timeDiffMS > 10000))){
			iKonkeAfSelfPrint("###########IAS Status Report diff(%d)\r\n", timeDiffMS);
			//report ias
			kZclIASZoneStatusUpdate(1, (1 << ALARM1) | (status), false);
			//red led blink 2 times
			if (kGetIndicatorNotDisturbModeFlg() != true &&
					(kNwkGetCurrentStatus() == ENS_ONLINE || kNwkGetCurrentStatus() == ENS_OFFLINE)){
				kLedOptTrigger(2, LED_FAST_BLINK_OFF_TIME_MS, LED_FAST_BLINK_OFF_TIME_MS, 2, LED_ON, LED_OFF);
			}
		}
		lastTimeMS = currentTimeMS;
		lastPreventTimeMS = currentTimeMS;
	}else {
		kZclIASZoneStatusUpdate(1, status, false);
	}
}
#endif

//̶¼Ŀǰϱ
void kUserScheduleTaskHandlerCallback(uint8_t schedule_id )
{
	iKonkeAfSelfPrint("###### SCH_ID(%d).\r\n", schedule_id);

	switch(schedule_id) {
		case (1):
		{
			//must judge gateway is or not made by konke
			//Received FCC0 Data,then report shotnap
			iKonkeAfSelfPrint("###### SCH_ID(%d),Is HengDa Gateway.\r\n", schedule_id,sEndpoint_Desp[0].IsHengDa_Gateway);
			if (  (kIsKonkeRemoteGateway() == true)
				||(sEndpoint_Desp[0].IsHengDa_Gateway )  )
			{
				kOptTunnelCommonReport(ECA_OPTDATA);
				//repeat overwrite heartbeat report time
				kNwkScheduleTaskRegister(1,  HEARTBEAT_TIME_MS, kUserScheduleTaskHandlerCallback);
			}else{
				if (cluster_obj_list[0].cluster != CLUSTER_UNKNOW)
				{
					if (cluster_obj_list[0].cluster  == ZCL_POWER_CONFIG_CLUSTER_ID){
						//kBatteryMonitorReadADC(true);
					}else {
						//add by maozj 20200512 report on off status
						if ((g_bIsNotKonkeGatewayFirstReportedFlg )&& kClustePeriodReportCheckIsSet(g_u8CurrentHeartEndpoint)== true){
							//ùreport intervalʹSDKreport
							//kNwkScheduleTaskStop(SCHEDULE_ALLOPT_ID);
						}else {
							kZclClusterHeartbeatControl(g_u8CurrentHeartEndpoint, ZCL_ON_OFF_CLUSTER_ID, ZCL_ON_OFF_ATTRIBUTE_ID);
						}
					}
					g_u8CurrentHeartEndpoint++;
					if (g_u8CurrentHeartEndpoint > g_ucRelayTotalNum){
						g_bIsNotKonkeGatewayFirstReportedFlg = true;
						//repeat overwrite heartbeat report time
						kNwkScheduleTaskRegister(1,  HEARTBEAT_TIME_MS, kUserScheduleTaskHandlerCallback);
						g_u8CurrentHeartEndpoint = 1;
					}else {
						kNwkScheduleTaskRegister(1,  1000, kUserScheduleTaskHandlerCallback);
					}
				}
			}
			break;
		}
		default: break;
	}
}

//س·ʱϱԸݲͬcluster޸
/*	DESP: recall scene rand delay report Attribute set
 * 	Auth: maozj.20191224.
 * */
void kZclClusterRecallSceneCallback(uint8_t endpoint,  uint16_t cluster, uint8_t command_id
		, bool reportEnable, bool sceneRecallFlg, bool reportGatewayEnable, bool reportChildDeviceEnable)
{
#ifdef ZCL_USING_ON_OFF_CLUSTER_SERVER
	kZclClusterSetPermitReportInfo(endpoint, reportEnable, sceneRecallFlg, reportGatewayEnable, reportChildDeviceEnable);
	iKonkeAfSelfPrint("####kZclClusterRecallSceneCallback\r\n");
#if 0
	//ʱ ֹյкű֮ǰĻ磬 ״̬ͬ
	EmberNodeId sender = emberGetSender();
	if (cluster == ZCL_ON_OFF_CLUSTER_ID && sender != 0x0000){
		uint8_t index = 0;
		uint8_t storedSequence = kSequenceFindByNodeid(sender, &index);

		iKonkeAfSelfPrint("##### LinkageExecute normal sender_node(%02x) index(%d) storedseq(0x%x) senderseq(0x%x)\r\n", sender, index, storedSequence, sequence);
		if (sequence < storedSequence && storedSequence - sequence  <= 50) {
			iKonkeAfSelfPrint("##### LinkageExecute sequence too early, sender_node(%02x) index(%d) storedseq(0x%x) senderseq(0x%x)\r\n", sender, index, storedSequence, sequence);
			//ִеǰ
			kZclClusterSetPermitReportInfo(endpoint, false, false);
		}else {
			kSequenceAdd(sender, sequence);
			kZclClusterSetPermitReportInfo(endpoint, true, false);
		}
	}
#endif
#endif
}
//ʱreport,ʱϱԣһ㲻Ҫ޸
bool kZclClusterReportChangeCallback(uint8_t endpoint, EmberAfClusterId clusterId, EmberAfAttributeId attributeId, EmberAfDifferenceType *difference)
{
	//ֹһϵ粻ϱ
	if (clusterId == ZCL_ON_OFF_CLUSTER_ID){
		ZclReportTableSt zclReportInfo;
		bool status = kZclClusterGetPermitReportInfo(endpoint,&zclReportInfo);
		iKonkeAfSelfPrint("######kZclClusterReportChangeCallback status(%d)ep(%d)enable(%d)scene(%d)\r\n",
				status, endpoint, zclReportInfo.reportEnable, zclReportInfo.sceneRecallFlg );
		if (status == true){
			if (zclReportInfo.reportEnable != true && zclReportInfo.sceneRecallFlg == true){
				//add by maozj 20200228
				if (*difference != 1){
					iKonkeAfSelfPrint("######kZclClusterReportChangeCallback attribute is not changed\r\n");
					return false;
				}
				uint32_t randDelayTimeMS = 0;
				if (endpoint == 1){
					randDelayTimeMS = kUtilsGetRandNum(REPORT_ATTR_MIN_RAND_NUM, REPORT_ATTR_MAX_RAND_NUM);
					emberEventControlSetDelayMS(kEndpoint1DelayReportAttrEventControl, randDelayTimeMS);
				}else if (endpoint == 2){
					randDelayTimeMS = kUtilsGetRandNum(REPORT_ATTR_MIN_RAND_NUM, REPORT_ATTR_MAX_RAND_NUM);
					emberEventControlSetDelayMS(kEndpoint2DelayReportAttrEventControl, randDelayTimeMS);
				}else if (endpoint == 3){
					randDelayTimeMS = kUtilsGetRandNum(REPORT_ATTR_MIN_RAND_NUM, REPORT_ATTR_MAX_RAND_NUM);
					emberEventControlSetDelayMS(kEndpoint3DelayReportAttrEventControl, randDelayTimeMS);
				}else if (endpoint == 4){
					randDelayTimeMS = kUtilsGetRandNum(REPORT_ATTR_MIN_RAND_NUM, REPORT_ATTR_MAX_RAND_NUM);
					emberEventControlSetDelayMS(kEndpoint4DelayReportAttrEventControl, randDelayTimeMS);
				}

				//жذ󶨷豸, 
				if( kZclNodeIsBindNotGatewayIeeeAddress(endpoint, ZCL_ON_OFF_CLUSTER_ID) == true) {
					iKonkeAfSelfPrint("Multi Control\r\n");
					kZclClusterSetPermitReportInfo(endpoint, true, false, false, true);
					kOptTunnelReportingPlagiarizeOriginal(endpoint, ZCL_ON_OFF_CLUSTER_ID, ZCL_ON_OFF_ATTRIBUTE_ID, CLUSTER_MASK_SERVER);
					//kZclClusterConditionallySendReport(endpoint, ZCL_ON_OFF_CLUSTER_ID, false, true);
				}
				iKonkeAfSelfPrint("####kZclClusterReportChangeCallback ep(%d) randtime(%dms)\r\n", endpoint, randDelayTimeMS);
				//ֱϱʱϱ
				return false;
			}else if (zclReportInfo.reportEnable != true && zclReportInfo.sceneRecallFlg != true){
				//ϵ紦ϱ
				iKonkeAfSelfPrint("$$$$$$Power On ep(%d)####\r\n", endpoint);
				return false;
			}else {
				iKonkeAfSelfPrint("####report####ep(%d)\r\n", endpoint);

				if (*difference == 0){
					return false;
				}
				//ͣʱϱ
				if (endpoint == 1){
					emberEventControlSetInactive(kEndpoint1DelayReportAttrEventControl);
				}else if (endpoint == 2){
					emberEventControlSetInactive(kEndpoint2DelayReportAttrEventControl);
				}else if (endpoint == 3){
					emberEventControlSetInactive(kEndpoint3DelayReportAttrEventControl);
				}else if (endpoint == 4){
					emberEventControlSetInactive(kEndpoint4DelayReportAttrEventControl);
				}

//				 if(clusterId == ZCL_ON_OFF_CLUSTER_ID)
//					 *difference = 1;
				//ϱ
				return true;

			}
		}
	}
	else
	{
		kZclClusterSetPermitReportInfo(endpoint, true, false, true, false);
		return true;
	}
	return false;
}


//ʱϱ¼ɸݲͬʱϱԶ޸
void kEndpoint1DelayReportAttrEventHandler(void)
{
	emberEventControlSetInactive( kEndpoint1DelayReportAttrEventControl);
	iKonkeAfSelfPrint("####kEndpoint1DelayReportAttrEventHandler\r\n");
	kZclClusterSetPermitReportInfo(1, true, false, true, false);
	//kZclClusterConditionallySendReport(1, ZCL_ON_OFF_CLUSTER_ID, true, false);
	kOptTunnelReportingPlagiarizeOriginal(1, ZCL_ON_OFF_CLUSTER_ID, ZCL_ON_OFF_ATTRIBUTE_ID, CLUSTER_MASK_SERVER);
	//kClusterAttrWriteReport(1, ZCL_ON_OFF_CLUSTER_ID, ZCL_ON_OFF_ATTRIBUTE_ID, (uint8_t *)kRelayChannelStatusGet(RELAY_CHANNEL1_ID), ZCL_BOOLEAN_ATTRIBUTE_TYPE);
}
void kEndpoint2DelayReportAttrEventHandler(void)
{
	emberEventControlSetInactive( kEndpoint2DelayReportAttrEventControl);
	iKonkeAfSelfPrint("####kEndpoint2DelayReportAttrEventHandler\r\n");
	kZclClusterSetPermitReportInfo(2, true, false, true, false);
	//kZclClusterConditionallySendReport(2, ZCL_ON_OFF_CLUSTER_ID, true, false);
	kOptTunnelReportingPlagiarizeOriginal(2, ZCL_ON_OFF_CLUSTER_ID, ZCL_ON_OFF_ATTRIBUTE_ID, CLUSTER_MASK_SERVER);
	//kClusterAttrWriteReport(2, ZCL_ON_OFF_CLUSTER_ID, ZCL_ON_OFF_ATTRIBUTE_ID, (uint8_t *)kRelayChannelStatusGet(RELAY_CHANNEL2_ID), ZCL_BOOLEAN_ATTRIBUTE_TYPE);
}
void kEndpoint3DelayReportAttrEventHandler(void)
{
	emberEventControlSetInactive( kEndpoint3DelayReportAttrEventControl);
	iKonkeAfSelfPrint("####kEndpoint3DelayReportAttrEventHandler\r\n");
	kZclClusterSetPermitReportInfo(3, true, false, true, false);
	//kZclClusterConditionallySendReport(3, ZCL_ON_OFF_CLUSTER_ID, true, false);
	kOptTunnelReportingPlagiarizeOriginal(3, ZCL_ON_OFF_CLUSTER_ID, ZCL_ON_OFF_ATTRIBUTE_ID, CLUSTER_MASK_SERVER);
	//kClusterAttrWriteReport(3, ZCL_ON_OFF_CLUSTER_ID, ZCL_ON_OFF_ATTRIBUTE_ID, (uint8_t *)kRelayChannelStatusGet(RELAY_CHANNEL3_ID), ZCL_BOOLEAN_ATTRIBUTE_TYPE);
}
void kEndpoint4DelayReportAttrEventHandler(void)
{
	emberEventControlSetInactive( kEndpoint4DelayReportAttrEventControl);
	iKonkeAfSelfPrint("####kEndpoint4DelayReportAttrEventHandler\r\n");
	kZclClusterSetPermitReportInfo(4, true, false, true, false);
	//kZclClusterConditionallySendReport(3, ZCL_ON_OFF_CLUSTER_ID, true, false);
	kOptTunnelReportingPlagiarizeOriginal(4, ZCL_ON_OFF_CLUSTER_ID, ZCL_ON_OFF_ATTRIBUTE_ID, CLUSTER_MASK_SERVER);
	//kClusterAttrWriteReport(3, ZCL_ON_OFF_CLUSTER_ID, ZCL_ON_OFF_ATTRIBUTE_ID, (uint8_t *)kRelayChannelStatusGet(RELAY_CHANNEL3_ID), ZCL_BOOLEAN_ATTRIBUTE_TYPE);
}

//LED˸ɣ̵ָLED״̬
void kUserLedActionDoneCallback(unsigned char id)
{
	iKonkeAfSelfPrint("##############kUserLedActionDoneCallback id(%d)##################\r\n", id);

//	if (id != LED_ALL_ID){
//		kPwmClearGradientCounterById(id - 1);
//	}else{
//		kPwmClearGradientCounterById(PWM1_ID);
//		kPwmClearGradientCounterById(PWM2_ID);
//		kPwmClearGradientCounterById(PWM3_ID);
//		kPwmClearGradientCounterById(PWM4_ID);
//	}

	kSetLedStatus(id);
}

#if Z30_DEVICE_AGING_ENABLE
//ϻѯصһʵϻڼLED˸̵תҲֻLED˸
void kUserFactorTestPollCallback(FactoryTestStatusEnum status)
{
	iKonkeAfSelfPrint("##############kUserFactorTestPollCallback status(%d)##################\r\n", status);
	static RelayOptEnum  eRelayStatus = EZAO_OFF;
	switch(status)
	{
		case FTS_NORMAL:
			break;
		case FTS_START:
			//ûϻȶ
			kNwkFactoryReset(false);
			//رջɫLED
//			LED_OPT_OFF(LED_SYS_ID);
			break;
		case FTS_AGING_15MIN:
			break;
		case FTS_AGING_8HOU_START:
			//رеɫLED,п֮ǰ˸
			LED_OPT_OFF(LED_ALL_ID);
			LED_OPT_OFF(LED_RADAR_ID);
			//ͬеLEDͼ̵
			for (uint8_t i = 1; i <= g_ucRelayTotalNum; i++){
				kRelayChannelOpt(g_ucRelayIdBuff[i-1], EZAO_OFF);
			}
			eRelayStatus = EZAO_ON;
			break;
		case  FTS_AGING_8HOU:
			//ת̵LEDҲͬ
			//kZclOnOffClusterServerOnOffControl(1, EOOC_TOGGLE);
			eRelayStatus = eRelayStatus == EZAO_ON?EZAO_OFF:EZAO_ON;
			if (eRelayStatus == EZAO_ON){
				LED_OPT_ON(LED_RADAR_ID);
			}else{
				LED_OPT_OFF(LED_RADAR_ID);
			}
			for (uint8_t i = 1; i <= g_ucRelayTotalNum; i++){
				kRelayChannelOpt(g_ucRelayIdBuff[i-1], eRelayStatus);
			}
			break;
		case  FTS_AGING_DONE:
			//ϻ,еLEDͼ̵
			LED_OPT_ON(LED_RADAR_ID);
			for (uint8_t i = 1; i <= g_ucRelayTotalNum; i++){
				kRelayChannelOpt(g_ucRelayIdBuff[i-1], EZAO_ON);
			}
			eRelayStatus = EZAO_ON;
			//еϵͳLEDҲҪ
//			LED_OPT_ON(LED_SYS_ID);
			break;
		case FTS_AGING_FORCE_EXIT:
			iKonkeAfSelfPrint("############## FactoryTestSatus is FTS_AGING_FORCE_EXIT\r\n");
			//ǿϻ
			kLedOptTrigger(LED_ALL_ID, LED_FAST_BLINK_ON_TIME_MS, LED_FAST_BLINK_OFF_TIME_MS, BLINK_DEAD, LED_ON, LED_IGNORE);
			break;
		case FTS_AGING_WAITING:
			break;
		case FTS_AGING_FORCE_REBOOT:
			halReboot();
			break;
		default:
			iKonkeAfSelfPrint("##############Erro: FactoryTestSatus is not exist\r\n");
			break;
	}
}
#endif
#if Z30_DEVICE_OTA_ENABLE
//ʼOTAcallbackﴦʹotaģĬcallback,Ͳ
void kOTAMoudleUserCallback(OTAStatusEnum status)
{
#if 1
	static bool flg = false; //ֹضϵ,otaʧܺ
	iKonkeAfSelfPrint("##############kOTAMoudleUserCallback status(%d)##################\r\n", status);
	switch(status)
	{
		case OTA_NORMAL:
			break;
		case OTA_START:
			//رɫLED
//			LED_OPT_OFF(LED_ALL_ID);
//			kLedOptTrigger(LED_ALL_ID, 2 * LED_FAST_BLINK_ON_TIME_MS, 14 * LED_FAST_BLINK_ON_TIME_MS,\
//					OTA_UPGRADE__CONTINUE_MAX_TIME_MS /(2 * LED_FAST_BLINK_ON_TIME_MS + 14 * LED_FAST_BLINK_ON_TIME_MS), LED_ON, LED_ON);
			kSetOTAStatus(OTA_START);
			flg = false;
			break;
		case OTA_DOWNLOAD_DONE:
		{
			uint8_t buffer[] = {"Konke download disable watchdog.....\r\n"};
		 	  //ע͵ Ȼ޷ÿŹµڶΪ൱ڼʱ
		  	emberSerialWriteData((uint8_t)APP_SERIAL, buffer, strlen((char *)buffer));
		  	halInternalDisableWatchDog(MICRO_DISABLE_WATCH_DOG_KEY);//add by maozj 20190308ļغúÿŹ
		  	kSetOTAStatus(OTA_DOWNLOAD_DONE);
		  	break;
		}
		case OTA_VERITY_SUCCEED:
		{
			//Уɹ¼̵״̬,Ҫλ̵ָ״̬
			//saveRelayStatusWhenOtaSucceed(relayTotalNum);
			//uint8_t relayStatus = 1;
			//halCommonSetToken(TOKEN_OTA_RELAY_STATUS, &relayStatus);
			//5S
			//kLedOptTrigger(LED_ALL_ID, 25 * LED_FAST_BLINK_ON_TIME_MS,  LED_FAST_BLINK_ON_TIME_MS, 1, LED_ON, LED_ON);
			kSetOTAStatus(OTA_NORMAL);
			break;
		}
		case OTA_FAILED:
		{
			if (flg != true){
				halInternalWatchDogEnabled();  //ʹܿŹ
				emberAfOtaStorageClearTempDataCallback();
//				kLedOptTrigger(LED_ALL_ID, LED_FAST_BLINK_ON_TIME_MS, LED_FAST_BLINK_ON_TIME_MS,\
//									LED_FAST_BLINK_CONTINUE_TIME_MS /(LED_FAST_BLINK_ON_TIME_MS + LED_FAST_BLINK_ON_TIME_MS), LED_ON, LED_ON);
				kSetOTAStatus(OTA_NORMAL);
				//uint8_t status = 0;
				//halCommonSetToken(TOKEN_OTA_RELAY_STATUS, &status);
				//emAfOtaClientStop(); //ռϣ δԣֹضϵһֱrequest 5
			}
			flg = true;
			break;
		}
		default:
			iKonkeAfSelfPrint("##############Err: OTA status is not exist\r\n");
			break;
	}

#endif
}
#endif
//5SĻصһ塢ʹɺȫرʱλ
void kUserNetworkExitCompleteCallback(void)
{
	bool bIsAllOffFlg = true;
	for (uint8_t i = 1; i <= GET_MAX_ENDPOINT(g_ucRelayTotalNum); i++){
		if (kZclOnOffClusterServerOnOffGet(i) == EOOS_ON){
			bIsAllOffFlg = false;
			break;
		}
	}
	if (bIsAllOffFlg == true){
		halReboot();
	}
}
#if 0
/*	DESP: iHORN device uart command message incoming and process interface.
 * 	Auth: dingmz_frc.20190513.
 * */
void iHORNMsgInComingPaser(UMsgNodeSt *pMsgNode )
{
	if( NULL == pMsgNode ) {
		return ;
	}

#if 1 // Just for debug
	emberAfCorePrint("\r\n-- MSG INCOMING[%d]:\r\n", pMsgNode->length);
	emberAfCorePrintBuffer(pMsgNode->buffer, pMsgNode->length, true);
	emberAfCorePrint("\r\n--------------------\r\n");
#endif

	// check for parsable packets
	if( pMsgNode->length < 12 /* Minimum Packet Length */ ) {
		iKonkeAfSelfPrint("Err: Unparsable Packets!!\r\n");
		return ;
	}
#if 0
	// FA 0A 01 60 00 03 FD 01 41 10 00 B7
	iHORNCmdFormatSt *pfmt = (iHORNCmdFormatSt *)pMsgNode->buffer;

	// retransmit message filtering


	emberAfCorePrint("SNAP: %X:%X:%X:%4X:%X:%X:%X\r\n", pfmt->preamble, pfmt->length
		, pfmt->opcode, NT32(pfmt->seq_devid), pfmt->vendor_id, pfmt->dev_type, pfmt->data1);
#endif
}
#endif

/*	DESP: OptData message incoming process callback..
 * 	PARAM[pframe][in/out] input command frame content, output command process result ack content.
 * 	Auth: dingmz_frc.20190701.
 * */
bool IsReadAttributeCmd = false;
kk_err_t kUserOODMessageIncoming(uint8_t channel, uint8_t opcode, uint8_t args_in_out[], uint8_t *length_in_out )
{
	if( NULL == args_in_out || NULL == length_in_out ) {
		return KET_ERR_INVALID_POINTER;
	}

	iKonkeAfSelfPrint("OOD-INCOMING: channel(%d), opcode(%X)--\r\n", channel, opcode);
	for(int index = 0; index < *length_in_out; ++index ) {
		iKonkeAfSelfPrint("%X ", args_in_out[index]);
	}
	iKonkeAfSelfPrint("--------------------------------------\r\n");

	switch(opcode) {
		case (0x00): // get the device snap.
		{
			uint8_t command = args_in_out[0];

			OnOffStatusEnum  status1= kZclOnOffClusterServerOnOffGet(1);
			OnOffStatusEnum  status2= kZclOnOffClusterServerOnOffGet(2);
			OnOffStatusEnum  status3= kZclOnOffClusterServerOnOffGet(3);
			OnOffStatusEnum  status4= kZclOnOffClusterServerOnOffGet(4);
			uint8_t channelValue1 = (status1 == EOOS_ON)?1:(status1 == EOOS_UNKNOW?0xFF:0);
			uint8_t channelValue2 = (status2 == EOOS_ON)?1:(status2 == EOOS_UNKNOW?0xFF:0);
			uint8_t channelValue3 = (status3 == EOOS_ON)?1:(status3 == EOOS_UNKNOW?0xFF:0);
			uint8_t channelValue4 = (status4 == EOOS_ON)?1:(status4 == EOOS_UNKNOW?0xFF:0);

			if (g_ucRelayTotalNum == 1){
				channelValue2 = 0xff; //0xffΪ˽ЭЧֵ
				channelValue3 = 0xff;
				channelValue4 = 0xff;
			}else if (g_ucRelayTotalNum == 2){
				channelValue3 = 0xff;
				channelValue4 = 0xff;
			}
			else if (g_ucRelayTotalNum == 3){
				channelValue4 = 0xff;
			}
			uint8_t mode = 0;
			for(uint8_t i=0;i<g_ucRelayTotalNum;i++)
			{
				if(sEndpoint_Desp[i].mode)
					mode |=(1<<i);
			}
			args_in_out[0] = 0x00;
			args_in_out[1] = channelValue1;
			args_in_out[2] = channelValue2;
			args_in_out[3] = channelValue3;
			args_in_out[4] = channelValue4;

			args_in_out[5] = sEndpoint_Desp[0].Relay_ID;
			args_in_out[6] = sEndpoint_Desp[1].Relay_ID;
			args_in_out[7] = sEndpoint_Desp[2].Relay_ID;
			args_in_out[8] = sEndpoint_Desp[3].Relay_ID;
			args_in_out[9] = mode;
			args_in_out[10] = sEndpoint_Desp[0].Scense_ID;
			args_in_out[11] = sEndpoint_Desp[1].Scense_ID;
			args_in_out[12] = sEndpoint_Desp[2].Scense_ID;
			args_in_out[13] = sEndpoint_Desp[3].Scense_ID;
			if(g_ucRelayTotalNum == 2)
			{
				args_in_out[7]  = 0xff;
				args_in_out[8]  = 0xff;
				args_in_out[12] = 0xff;
				args_in_out[13] = 0xff;
			}
			else if(g_ucRelayTotalNum == 3)
			{
				args_in_out[8] 	= 0xff;
				args_in_out[13] = 0xff;
			}
			args_in_out[14] = kGetIndicatorNotDisturbModeFlg();
			iKonkeAfSelfPrint("OOOOOOPCODE: 1(%d), 2(%d), 3(%d)\r\n", args_in_out[1], args_in_out[2], args_in_out[3]);
			*length_in_out = 15;
			if((sEndpoint_Desp[0].IsHengDa_Gateway  == false)&&(IsReadAttributeCmd))
			{
				sEndpoint_Desp[0].IsHengDa_Gateway = true;
				kSetBindConfigInfo(sEndpoint_Desp);
			}

			break;
		}
		case (0x12):													//
		{
			uint8_t KeyId 		= channel;
			uint8_t Mode 	= args_in_out[0] ;
			if( (KeyId >0) && (KeyId <=g_ucRelayTotalNum) ){
				args_in_out[0] = ERR_NO_NONE;
				sEndpoint_Desp[0].IsHengDa_Gateway  = true;
				if(Mode == 0){											//ƿģʽ
					uint8_t Relay_ID = args_in_out[1] ;
					if((Relay_ID >=1)&&(Relay_ID <= g_ucRelayTotalNum)){
						sEndpoint_Desp[KeyId-1].mode = false;
						sEndpoint_Desp[KeyId-1].Relay_ID = Relay_ID;
					}else{
						args_in_out[0] = ERR_NO_COMMAND_FORMAT;
					}
				}
				else if(Mode == 1){										//龰ģʽ
					uint8_t Scenes_ID = args_in_out[1];
					if((Scenes_ID >=0)&&(Scenes_ID <= 0xFF)){
						sEndpoint_Desp[KeyId-1].mode = true;
						sEndpoint_Desp[KeyId-1].Scense_ID = Scenes_ID;
					}else{
						args_in_out[0] = ERR_NO_COMMAND_FORMAT;
					}
				}
				else{
					args_in_out[0] = ERR_NO_COMMAND_FORMAT;
				}

			}else{
				args_in_out[0] = ERR_NO_COMMAND_FORMAT;
			}
			iKonkeAfSelfPrint("Bind config,keyid= %d,Mode= %d,data = %d\r\n", KeyId ,Mode,args_in_out[1]);
			if(args_in_out[0] == ERR_NO_NONE)
				kSetBindConfigInfo(sEndpoint_Desp);
			args_in_out[2] = args_in_out[1];
			args_in_out[1] = Mode;
			*length_in_out = 3;
			break;
		}
		case (0xFE):
		{
			//set disturb mode
			uint8_t mode = args_in_out[0];
			if (mode != 0x00 && mode != 0x01){
				args_in_out[0] = ERR_NO_COMMAND_FORMAT;
			}else {
				//洢ű־
				kSetIndicatorNotDisturbModeFlg(mode);
				////State Sync////
				if (kLedIsBlinking(LED_ALL_ID) != true)	{
					kSetLedStatus(LED_ALL_ID);
				}
				args_in_out[0] = ERR_NO_NONE;
			}
			iKonkeAfSelfPrint("Disturb Mode(%d)\r\n", mode);
			args_in_out[1] = mode;
			*length_in_out = 2;
			if(sEndpoint_Desp[0].IsHengDa_Gateway  == false)
			{
				sEndpoint_Desp[0].IsHengDa_Gateway = true;
				kSetBindConfigInfo(sEndpoint_Desp);
			}
			break;
		}
		case (0xFF):
		{
			uint8_t permitJoinTimeS = args_in_out[0]; //unit:s
			iKonkeAfSelfPrint("###Opcode is channel(%d) JoinPermitTime(0x%X)!!\r\n",channel,  permitJoinTimeS);
			//·Эͬ,Ƶ˸(OTA)ʱЭͬ
			if (kLedIsBlinking(LED_ALL_ID) != true
					&& permitJoinTimeS != 0
					&& kNwkGetCurrentStatus() != ENS_JOINING){
				iKonkeAfSelfPrint("####LED Blink\r\n");
				kLedOptTrigger(LED_ALL_ID,  LED_FAST_BLINK_ON_TIME_MS, LED_FAST_BLINK_OFF_TIME_MS,
						permitJoinTimeS * 1000/(LED_FAST_BLINK_ON_TIME_MS+LED_FAST_BLINK_OFF_TIME_MS), LED_ON, LED_OFF);
			}else if (kLedIsBlinking(LED_ALL_ID) == true
					&& kGetOTAStatus() == OTA_NORMAL
					&& permitJoinTimeS == 0
					&& kNwkGetCurrentStatus() != ENS_JOINING){
				iKonkeAfSelfPrint("####LED Blink over\r\n");
				kLedOptTrigger(LED_ALL_ID, 0, 0, 0, LED_OFF, LED_IGNORE);
//				kLEDOffAction(LED_ALL_ID);
				kSetLedStatus(LED_ALL_ID);
			}
			return KET_NO_RESPONSE;
		}

		default: {
			iKonkeAfSelfPrint("Err: opcode is not exist(%d:%X)!!\r\n", channel, opcode);
			args_in_out[0] = ERR_NO_OPCODE;
			*length_in_out = 1;
			break;
		}
	}

	return KET_OK;
}
void kSyncStateWhenJoinSuccessEventHandler(void)
{
	static  uint8_t  ucCount = 0;
	emberEventControlSetInactive(kSyncStateWhenJoinSuccessEventControl);
	++ucCount;
	iKonkeAfSelfPrint("kSyncStateWhenJoinSuccessEventHandler,Count = %d\r\n",ucCount);
	switch(ucCount)
	{
		case 1:
		{
			for (uint8_t i = 1; i <= g_ucRelayTotalNum; i++)
			{
				uint8_t value = 0;
				EmberStatus status = emberAfReadServerAttribute(i,ZCL_ON_OFF_CLUSTER_ID,ZCL_ON_OFF_ATTRIBUTE_ID,
														       (uint8_t *)&(value),sizeof(value));
				kZclClusterSetPermitReportInfo(i, true, false, false, false);
				emberAfWriteServerAttribute(i,ZCL_ON_OFF_CLUSTER_ID,ZCL_ON_OFF_ATTRIBUTE_ID,
										   (uint8_t *)&value,ZCL_BOOLEAN_ATTRIBUTE_TYPE);
				kZclClusterSetPermitReportInfo(i, true, false, false, false);
			}
			break;
		}
		case 2:case 3:
		case 4:
		{
			if(ucCount == 4)
			{
				for (uint8_t i = 1; i <= g_ucRelayTotalNum; i++){
					kZclClusterSetPermitReportInfo(i, false, false, true, false);
				}
			}
			break;
		}
		default:
		{
			ucCount = 0;
			return;
		}
	}
	emberEventControlSetDelayMS(kSyncStateWhenJoinSuccessEventControl,400);
}
//оƬϵʱ¼һ㴦̵״ָ̬߽SWDΪͨIO,Ҳgpioȡƽ޸ͬһ͵Ĳͬͺ
/*	DESP: system setup delay callback handler, called once.
 * 	Auth: dingmz_frc.20190628.
 * */
void kkSystemSetUpEventHandler(void )
{
	emberEventControlSetInactive(kkSystemSetUpEventControl);

	if( emberAfNetworkState() == EMBER_JOINED_NETWORK  ) {
		// 10 - 40s random report snap status.
		//emberEventControlSetDelayMS(kkHeartBeatLoopEvent, 1000 * kUtilsGetRandNum(5, 35));
	}else {
		//JoinNetworkStart();
	}
		emberAfClearResponseData();		//ֹճ
		// Ҫ10SWDӿڣSWDŲڳ˿ڣ
		//GPIO_DbgSWDClkEnable(false);
		//¼̵״̬
		bool relayStatusBuffer[] = {false, false, false};
		for (uint8_t i = 1; i <= g_ucRelayTotalNum; i++){
			uint8_t value = 0;
			//do not report attr,just restore on off status when chip reset.
			EmberStatus status = emberAfReadServerAttribute(i,
													 ZCL_ON_OFF_CLUSTER_ID,
													 ZCL_ON_OFF_ATTRIBUTE_ID,
													 (uint8_t *)&(value),
													 sizeof(value));
			iKonkeAfSelfPrint("#######read attribute success ep(%d) value(%d)", i, value);
			relayStatusBuffer[i-1] = value;
		}

		//ָLEDָʾͼ̵
		for (uint8_t i = 1; i <= g_ucRelayTotalNum; i++){
			//uint8_t value = 0;
			//do not report attr,just restore on off status when chip reset by bootloader or enable restore,BTL 0x02
			if ((g_bIsRecoveryRelayStatus==0)&& halGetExtendedResetInfo() != 0x0201 && halGetExtendedResetInfo() != 0x0601){
				relayStatusBuffer[i-1] = false;
			}
			iKonkeAfSelfPrint("###########EP(%d), status(%d)\r\n", i, relayStatusBuffer[i-1]);
			kZclClusterSetPermitReportInfo(i, true, false, false, false);
			emberAfWriteServerAttribute(i,
										 ZCL_ON_OFF_CLUSTER_ID,
										 ZCL_ON_OFF_ATTRIBUTE_ID,
										 (uint8_t *)&(relayStatusBuffer[i-1]),
										 ZCL_BOOLEAN_ATTRIBUTE_TYPE);
			kZclClusterSetPermitReportInfo(i, true, false, false, false);
	#if 1
			power_on_sync[i - 1] = true;
			kRelayChannelOpt(i == 1?RELAY_CHANNEL1_ID:(i == 2?RELAY_CHANNEL2_ID:(i == 3?RELAY_CHANNEL3_ID:RELAY_CHANNEL4_ID)) \
					,relayStatusBuffer[i-1] == false? EZAO_OFF : EZAO_ON);
	#else
			RELAY_ID_ENUM eRelayID = (i == 1)?RELAY_CHANNEL1_ID:(i == 2?RELAY_CHANNEL2_ID:RELAY_CHANNEL3_ID);
			RelayOptEnum eOpt = relayStatusBuffer[i-1] == false? EZAO_OFF : EZAO_ON;
			kRelayChannelControl(eRelayID, eOpt);

			RelayStatusSt RelaySt;
			RelaySt.u8RelayChannelId = eRelayID;
			Relayst.opt = eOpt;
			kUserRelayLedCallback(zast);
	#endif
			}
		memcpy(sEndpoint_Desp,kGetBindConfigInfo(),sizeof(sEndpoint_Desp));
		uint8_t  status;
		halCommonGetToken(&status, TOKEN_JOIN_FAILED_FLAG);
		kSetLedStatus(LED_ALL_ID);
		if(kNwkGetCurrentStatus() == ENS_LEAVED){
			if(status)
			{
				status = 0;
				halCommonSetToken(TOKEN_JOIN_FAILED_FLAG, &status);
			}
			else
			{
				kNwkFactoryReset(false);
				//steering timeout can be set
				iKonkeAfSelfPrint("#####Start Steering\r\n");
				kNwkJoiningStart(NWK_STEERING_TIMEOUT_MS, JoinCompleteCallback);
			}
		}
	kOptTunnelTrytoWriteModelIdenfierMfgToken();
#if 0
	kOTAMoudleCallback(OTA_VERITY_SUCCEED);
#endif
}

void kDelaySetLedStatusEventHandler(void)
{
	emberEventControlSetInactive(kDelaySetLedStatusEventControl);
	//otaʧܺɹʧܣ led״̬

#if 0
	//ģʽ״̬
	for (uint8_t i = 0; i < ENDPOINT_MAX_NUM; i++){
		if (g_stNoDisturbModeStatus[i].status == NO_DISTURB_RELAY_ON_LED_10S_DELAY){
			g_stNoDisturbModeStatus[i].status = NO_DISTURB_RELAY_ON_LED_OFF;
			//˸
			if (kLedIsBlinking(LED_ALL_ID) != true){
				kLEDOffAction(LED_ALL_ID);
			}
		}
	}
#endif

#if 0
	//Զ
	//avoid IEEE token cannot cleared
	kNwkFactoryReset(false);
	//steering timeout can be set
	iKonkeAfSelfPrint("#####Start Steering\r\n");
	kNwkJoiningStart(NWK_STEERING_TIMEOUT_MS, JoinCompleteCallback);
#endif
}



//otaʧܻɹʧܺLED˸ɺҪݲͬƷ޸
static void kSetLedStatus(LED_ID_ENUM id)
{
	if(kGetIndicatorNotDisturbModeFlg()){
		LED_OPT_OFF(id);
	}
	else{
		LED_OPT_ON(id);
	}
}


static bool kEndpointIsValid(uint8_t endpoint)
{
	bool ret = false;
	if (endpoint == 1){
		ret = true;
	}else if (endpoint == 2 && (g_ucRelayTotalNum == 2 || g_ucRelayTotalNum == 3 || g_ucRelayTotalNum == 4)){
		ret = true;
	}else if (endpoint == 3 && (g_ucRelayTotalNum == 3 || g_ucRelayTotalNum == 4)){
		ret = true;
	}else if (endpoint == 4 && g_ucRelayTotalNum == 4){
		ret = true;
	}else if (endpoint == 0xFF){
		ret = true;
	}
	return ret;
}


static void kLEDOffAction(LED_ID_ENUM led_id)
{
	iKonkeAfSelfPrint("LED_Off_Action LED_ID (%d).\r\n", led_id);
	kLedOptTrigger(led_id, 0, 0, 0, LED_OFF, LED_IGNORE);
//	if (kGetIndicatorNotDisturbModeFlg() == false){
//		iKonkeAfSelfPrint("is not NotDisturbMode.\r\n");
//		switch (led_id)
//		{
//			case LED1_ID:
//			{
//				kPwmDriverhandler(kPwmGetIndexByID(PWM1_ID), ELP_ANY, OFF_DISTURB_MODE_LED_OFF_LEVEL);
//				break;
//			}
//			case LED2_ID:
//			{
//				kPwmDriverhandler(kPwmGetIndexByID(PWM2_ID), ELP_ANY, OFF_DISTURB_MODE_LED_OFF_LEVEL);
//				break;
//			}
//			case LED3_ID:
//			{
//				kPwmDriverhandler(kPwmGetIndexByID(PWM3_ID), ELP_ANY, OFF_DISTURB_MODE_LED_OFF_LEVEL);
//				break;
//			}
//			case LED4_ID:
//			{
//				kPwmDriverhandler(kPwmGetIndexByID(PWM4_ID), ELP_ANY, OFF_DISTURB_MODE_LED_OFF_LEVEL);
//				break;
//			}
//			case LED_ALL_ID:
//			{
//#ifdef SINGLE_LIGHT_PANEL
//				kPwmDriverhandler(kPwmGetIndexByID(PWM1_ID), ELP_ANY, OFF_DISTURB_MODE_LED_OFF_LEVEL);
//#endif
//
//#ifdef DUAL_LIGHT_PANEL
//				kPwmDriverhandler(kPwmGetIndexByID(PWM1_ID), ELP_ANY, OFF_DISTURB_MODE_LED_OFF_LEVEL);
//				kPwmDriverhandler(kPwmGetIndexByID(PWM2_ID), ELP_ANY, OFF_DISTURB_MODE_LED_OFF_LEVEL);
//#endif
//
//#ifdef THREE_LIGHT_PANEL
//				kPwmDriverhandler(kPwmGetIndexByID(PWM1_ID), ELP_ANY, OFF_DISTURB_MODE_LED_OFF_LEVEL);
//				kPwmDriverhandler(kPwmGetIndexByID(PWM2_ID), ELP_ANY, OFF_DISTURB_MODE_LED_OFF_LEVEL);
//				kPwmDriverhandler(kPwmGetIndexByID(PWM3_ID), ELP_ANY, OFF_DISTURB_MODE_LED_OFF_LEVEL);
//
//#endif
//#ifdef FOUR_LIGHT_PANEL
//				kPwmDriverhandler(kPwmGetIndexByID(PWM1_ID), ELP_ANY, OFF_DISTURB_MODE_LED_OFF_LEVEL);
//				kPwmDriverhandler(kPwmGetIndexByID(PWM2_ID), ELP_ANY, OFF_DISTURB_MODE_LED_OFF_LEVEL);
//				kPwmDriverhandler(kPwmGetIndexByID(PWM3_ID), ELP_ANY, OFF_DISTURB_MODE_LED_OFF_LEVEL);
//				kPwmDriverhandler(kPwmGetIndexByID(PWM4_ID), ELP_ANY, OFF_DISTURB_MODE_LED_OFF_LEVEL);
//#endif
//				break;
//			}
//			default:
//				break;
//		}
//	}
}

static bool kClustePeriodReportCheckIsSet(uint8_t endpoint)
{
	uint16_t u16MinTimeMS = 0;
	uint16_t u16MaxTimeMS = 0;
	if (endpoint <= GET_MAX_ENDPOINT(g_ucRelayTotalNum)){
		bool status = kkClusterGetReportingPeriod(endpoint, ZCL_ON_OFF_CLUSTER_ID, ZCL_ON_OFF_ATTRIBUTE_ID, &u16MinTimeMS, &u16MaxTimeMS);
		if (status == true){
			if (u16MaxTimeMS > 0){
				return true;
			}
		}
	}
	return false;
}

void kRadarCheckEventHandler(void)
{
//	emberEventControlSetInactive(kRadarCheckEventControl);
//
//	if (kGetFactoryTestStatus() == FTS_AGING_8HOU 	\
//		|| kGetFactoryTestStatus() == FTS_AGING_DONE 	\
//		|| kGetFactoryTestStatus() == FTS_AGING_WAITING 	\
//		|| kGetFactoryTestStatus() == FTS_AGING_WAITING_SECOND_PRESS){
//		return;
//	}
//
////	uint8_t Radar_st = GPIO_PinInGet(RADAR_PORT, RADAR_PIN);
//	static uint8_t Radar_count = 0;
//	if (GPIO_PinInGet(RADAR_PORT, RADAR_PIN)){
//		Radar_count ++;
//	}else{
//		Radar_count = 0;
//	}
//
//	if (Radar_count >= 2){
//		iKonkeAfSelfPrint("Radar Action.\r\n");
//		Human_body_induction_flag = true;
//		Radar_count = 0;
//		emberEventControlSetActive(kRadarLedEventControl);
//	}
//
//	emberEventControlSetDelayMS(kRadarCheckEventControl, 100);
}
void kRadarLedEventHandler(void)
{
//	emberEventControlSetInactive(kRadarLedEventControl);
//
//	if (kGetFactoryTestStatus() == FTS_AGING_8HOU 	\
//		|| kGetFactoryTestStatus() == FTS_AGING_DONE 	\
//		|| kGetFactoryTestStatus() == FTS_AGING_WAITING 	\
//		|| kGetFactoryTestStatus() == FTS_AGING_WAITING_SECOND_PRESS){
//		return;
//	}
//
//	bool OnOffFlag = false;
#ifdef SINGLE_LIGHT_PANEL
//	OnOffFlag |= kZclOnOffClusterServerOnOffGet(1) == EOOS_ON?true:false;
#endif
#ifdef DUAL_LIGHT_PANEL
//	OnOffFlag |= kZclOnOffClusterServerOnOffGet(1) == EOOS_ON?true:false;
//	OnOffFlag |= kZclOnOffClusterServerOnOffGet(2) == EOOS_ON?true:false;
#endif
#ifdef THREE_LIGHT_PANEL
//	OnOffFlag |= kZclOnOffClusterServerOnOffGet(1) == EOOS_ON?true:false;
//	iKonkeAfSelfPrint("OnOffFlag by endpoint1 : (%d).\r\n",OnOffFlag);
//	OnOffFlag |= kZclOnOffClusterServerOnOffGet(2) == EOOS_ON?true:false;
//	iKonkeAfSelfPrint("OnOffFlag by endpoint2 : (%d).\r\n",OnOffFlag);
//	OnOffFlag |= kZclOnOffClusterServerOnOffGet(3) == EOOS_ON?true:false;
//	iKonkeAfSelfPrint("OnOffFlag by endpoint3 : (%d).\r\n",OnOffFlag);
#endif
#ifdef FOUR_LIGHT_PANEL
//	OnOffFlag |= kZclOnOffClusterServerOnOffGet(1) == EOOS_ON?true:false;
//	iKonkeAfSelfPrint("OnOffFlag by endpoint1 : (%d).\r\n",OnOffFlag);
//	OnOffFlag |= kZclOnOffClusterServerOnOffGet(2) == EOOS_ON?true:false;
//	iKonkeAfSelfPrint("OnOffFlag by endpoint2 : (%d).\r\n",OnOffFlag);
//	OnOffFlag |= kZclOnOffClusterServerOnOffGet(3) == EOOS_ON?true:false;
//	iKonkeAfSelfPrint("OnOffFlag by endpoint3 : (%d).\r\n",OnOffFlag);
//	OnOffFlag |= kZclOnOffClusterServerOnOffGet(4) == EOOS_ON?true:false;
//	iKonkeAfSelfPrint("OnOffFlag by endpoint4 : (%d).\r\n",OnOffFlag);
#endif

//	iKonkeAfSelfPrint("Is light ON:(%d), is human body induction:(%d).\r\n",OnOffFlag, Human_body_induction_flag);
//
//	if (OnOffFlag == true){
//		kLedOptTrigger(LED_RADAR_ID, 0, 0, 0, LED_ON, LED_IGNORE);
//		Human_body_induction_flag = false;
//	}else if (Human_body_induction_flag == true){
//		kLedOptTrigger(LED_RADAR_ID, RADAR_ON_TIME_MS, 0, 1, LED_ON, LED_OFF);
//		Human_body_induction_flag = false;
////		emberEventControlSetDelayMS(kRadarLedEventControl, RADAR_ON_TIME_MS);
//	}else{
//		kLedOptTrigger(LED_RADAR_ID, RADAR_ON_TIME_MS, 0, 1, LED_ON, LED_OFF);
//	}
}
void kSetBindConfigInfo(Endpoint_Desp* info)
{
	halCommonSetToken(TOKEN_BIND_CONFIG_INFO, info);
}

Endpoint_Desp* kGetBindConfigInfo(void)
{
	halCommonGetToken(sEndpoint_Desp, TOKEN_BIND_CONFIG_INFO);
	return sEndpoint_Desp;
}

void Operate_LED_Action(LED_ID_ENUM LED_Id)
{
//	if(kGetIndicatorNotDisturbModeFlg()){
//		kLedOptTrigger(LED_Id,  LED_SLOW_BLINK_ON_TIME_MS, 20, 1, LED_ON, LED_OFF);
//	}
//	else{
//		kLedOptTrigger(LED_Id, 20, LED_SLOW_BLINK_OFF_TIME_MS, 1, LED_OFF, LED_ON);
//	}
}
uint32_t SceneActionOTATime[4] = 0;
boolean	 SceneActionEnableflag[4] = {false};
/******************************************************
*	Para id  0 -3  ep1ep4
*
******************************************************/
void Scense_Operation(uint8_t id)
{
	uint64_t currentTimes;
	currentTimes = halCommonGetInt64uMillisecondTick();
	if (SceneActionOTATime[id] == 0){
		SceneActionEnableflag[id] = true;
		SceneActionOTATime[id] = currentTimes;
	}else if (currentTimes - SceneActionOTATime[id] >= 100){
		SceneActionEnableflag[id] = true;
		SceneActionOTATime[id] = currentTimes;
	}

	if (SceneActionEnableflag[id] == true){
		kZclSceneRecall(id+1, 0x00, sEndpoint_Desp[id].Scense_ID, 0x00);

		if (kGetOTAStatus() == OTA_NORMAL && kLedIsBlinking(LED_ALL_ID) != true){
			Operate_LED_Action(2+id);
			}
		}
		SceneActionEnableflag[id] = false;

}
uint8_t Find_Endpoint_ID_By_Key_ID(KEY_ID_ENUM Key_ID)
{
	uint8_t temp = Key_ID -2;
	return sEndpoint_Desp[temp].Relay_ID;
}
//void Operate_LED_By_Relay_ID(uint8_t relay_id,uint8_t status)
//{
//	uint8_t  reValue = 0;
//	for(uint8_t i =0;i<4;i++)
//	{
//		if(sEndpoint_Desp[i].Relay_ID == relay_id)
//		{
//			if(status)
//				LED_OPT_ON(i+2);
//			else
//				LED_OPT_OFF(i+2);
//		}
//
//	}
//}
//EmberEventControl kDelayRecoverReportEventControl;
//uint8_t   Current_Ep = 0xff;
//void kDelayRecoverReportEventHandler(void)
//{
//	iKonkeAfSelfPrint("#############kDelayRecoverReportEventControl Current_Ep = 0x%x\r\n", Current_Ep);
//	emberEventControlSetInactive(kDelayRecoverReportEventControl);
//	kZclClusterSetPermitReportInfo(Current_Ep, true, false, true, true);
//	Current_Ep = 0xff;
//}
void Control_Relay(KEY_ID_ENUM Key_ID)
{
	switch(Key_ID)
	{
		case KEY1_ID:
		{
			emberEventControlSetInactive(kEndpoint1DelayReportAttrEventControl);
			Operate_LED_Action(LED1_ID);
			break;
		}
		case KEY2_ID:
		{
			emberEventControlSetInactive(kEndpoint2DelayReportAttrEventControl);
			Operate_LED_Action(LED2_ID);
			break;
		}
		case KEY3_ID:
		{
			emberEventControlSetInactive(kEndpoint3DelayReportAttrEventControl);
			Operate_LED_Action(LED3_ID);
			break;
		}
		case KEY4_ID:
		{
			emberEventControlSetInactive(kEndpoint4DelayReportAttrEventControl);
			Operate_LED_Action(LED4_ID);
			break;
		}

		default:
			break;
	}
	uint8_t endpoint = Find_Endpoint_ID_By_Key_ID(Key_ID);
	//Current_Ep = endpoint;
	if(sEndpoint_Desp[0].IsHengDa_Gateway)
		kZclClusterSetPermitReportInfo(endpoint, true, false, false, true);
	else
		kZclClusterSetPermitReportInfo(endpoint, true, false, true, true);
	kZclOnOffClusterServerOnOffControl(endpoint, EOOC_TOGGLE);
	iKonkeAfSelfPrint("Check endpoint=%d,result = %d\r\n",endpoint,Find_Endpoint_ID_By_Key_ID(KEY1_ID));
	//emberEventControlSetDelayMS(kDelayRecoverReportEventControl, 50);
}

void zcl_buffer_send(uint16_t destination, uint8_t srcEndpoint, uint8_t dstEndpoint)
{
	EmberStatus status;

	extern uint8_t appZclBuffer[EMBER_AF_MAXIMUM_SEND_PAYLOAD_LENGTH];
	extern uint16_t appZclBufferLen;
	extern bool zclCmdIsBuilt;
	extern EmberApsFrame globalApsFrame;

	emAfApsFrameEndpointSetup(srcEndpoint, dstEndpoint);

	if(emberAfPreCliSendCallback(&globalApsFrame,
								emberAfGetNodeId(),
								destination,
								appZclBuffer,
								appZclBufferLen))
    {
        return;
	}

	if(destination >= EMBER_BROADCAST_ADDRESS){
		status = emberAfSendBroadcast(destination,
									  &globalApsFrame,
									  appZclBufferLen,
									  appZclBuffer);
	}else{
		status = emberAfSendUnicast(EMBER_OUTGOING_DIRECT,
									destination,
									&globalApsFrame,
									appZclBufferLen,
									appZclBuffer);
	}

	if(status != EMBER_SUCCESS){
    }
}

void scene_install_buf(uint8_t command_t,  uint16_t cluster_ID, uint8_t *buffer, uint8_t buffer_len)
{
    uint8_t data_type = ZCL_INT8U_ATTRIBUTE_TYPE;

	zclBufferSetup(ZCL_CLUSTER_SPECIFIC_COMMAND|ZCL_FRAME_CONTROL_CLIENT_TO_SERVER, cluster_ID, command_t);

	if (command_t != ZCL_READ_ATTRIBUTES_COMMAND_ID)
    {
		zclBufferAddBuffer(buffer, buffer_len);
	}
}
void kZclSceneRecall(uint8_t srcEndpoint, uint16_t groupId, uint8_t sceneId, uint16_t time)
{
	iKonkeAfSelfPrint("++++++sceneId 0x%x\r\n", sceneId);
	uint8_t private_cluster_payload_buf[64] = {0};
	uint8_t bufCount = 0;

	if( kNwkGetCurrentStatus() == ENS_ONLINE ) {
		// check binding table
		kk_err_t err = kNwkClusterBindingObjIsOK(srcEndpoint, ZCL_SCENES_CLUSTER_ID);
		if( err == KET_ERR_NON_EXIST ) {
			kNwkClusterBindingTrigger(NULL);
		}
	}

	for (int i = 0; i < EMBER_AF_PLUGIN_SCENES_TABLE_SIZE; i++) {
		EmberAfSceneTableEntry entry;
		emberAfPluginScenesServerRetrieveSceneEntry(entry, i);

		if (entry.endpoint == srcEndpoint) {
			iKonkeAfSelfPrint("####Scene GroupId(0x%02x) SceneId(%01x) EP(%d)\r\n",
						entry.groupId, entry.sceneId, entry.endpoint);

			emAfApsFrameEndpointSetup(srcEndpoint, 0xFF);
			bufCount = 0;
			private_cluster_payload_buf[bufCount++] = entry.groupId & 0xff;
			private_cluster_payload_buf[bufCount++] = (entry.groupId >> 8) & 0xff;
			private_cluster_payload_buf[bufCount++] = entry.sceneId;
			private_cluster_payload_buf[bufCount++] = entry.transitionTime & 0xff;
			private_cluster_payload_buf[bufCount++] = (entry.transitionTime >> 8) & 0xff;

			scene_install_buf(ZCL_RECALL_SCENE_COMMAND_ID, ZCL_SCENES_CLUSTER_ID,
							  private_cluster_payload_buf, bufCount);
			emberAfSendMulticast( entry.groupId,
								   &globalApsFrame,
								   appZclBufferLen,
								   appZclBuffer);

			if (srcEndpoint == 1){
				emberEventControlSetDelayMS(kEndpoint1DelayReportAttrEventControl, 100);
			}else if (srcEndpoint == 2){
				emberEventControlSetDelayMS(kEndpoint2DelayReportAttrEventControl, 100);
			}else if (srcEndpoint == 3){
				emberEventControlSetDelayMS(kEndpoint3DelayReportAttrEventControl, 100);
			}else if (srcEndpoint == 4){
				emberEventControlSetDelayMS(kEndpoint4DelayReportAttrEventControl, 100);
			}

			return;
		}else{
			iKonkeAfSelfPrint("####2222 Scene GroupId(0x%02x) SceneId(%01x) EP(%d)\r\n",
						entry.groupId, entry.sceneId, entry.endpoint);
		}
	}

    emberAfGetCommandApsFrame()->sourceEndpoint      = srcEndpoint;
	emberAfGetCommandApsFrame()->destinationEndpoint = 1;

	bufCount = 0;
	private_cluster_payload_buf[bufCount++] = groupId && 0xff;
	private_cluster_payload_buf[bufCount++] = (groupId >> 8) && 0xff;
	private_cluster_payload_buf[bufCount++] = sceneId;
	private_cluster_payload_buf[bufCount++] = time && 0xff;
	private_cluster_payload_buf[bufCount++] = (time >> 8) && 0xff;

	scene_install_buf(ZCL_RECALL_SCENE_COMMAND_ID, ZCL_SCENES_CLUSTER_ID,
	private_cluster_payload_buf, bufCount);

	zcl_buffer_send(0x0000, srcEndpoint, 1);
}

kk_err_t kOptKeyStateReport(uint8_t KeyID,uint8_t Relay_ID,uint8_t Relay_State)
{
	uint8_t g_tmp_buffer[20];
	uint8_t bufCount = 0;
	extern uint8_t generatedDefaults[];

	g_tmp_buffer[bufCount++] = 0; // totle length
	g_tmp_buffer[bufCount++] = kUtilsOct2Value((char *)&generatedDefaults[33 +  9], 2); //basicеmodel idĸֽ
	g_tmp_buffer[bufCount++] = kUtilsOct2Value((char *)&generatedDefaults[33 + 11], 2);
	g_tmp_buffer[bufCount++] = kUtilsOct2Value((char *)&generatedDefaults[33 + 13], 2);
	g_tmp_buffer[bufCount++] = kUtilsOct2Value((char *)&generatedDefaults[33 + 15], 2);
	g_tmp_buffer[bufCount++] = KeyID;
	g_tmp_buffer[bufCount++] = 0x13;
	g_tmp_buffer[bufCount++] = Relay_State;
	g_tmp_buffer[bufCount++] = Relay_ID;

	g_tmp_buffer[0] = bufCount - 1;

	return kOptTunnelCommonReportSend(ECA_OPTDATA, g_tmp_buffer, bufCount);
}
